//**************************************************************************//
//  Unit        | cba\̃bpNX̒`                            //
//  Version     | 1.00                                                      //
//--------------------------------------------------------------------------//
//  File Name   | DCBObj.pas                                                //
//  Platform    | Windows2000                                               //
//  Compiler    | Delphi6                                                   //
//  Last Update | 2002/10/ 3                                                //
//--------------------------------------------------------------------------//
//  Copyright (c) 2002 Hitwareland Corporation.                             //
//  All rights reserved.                                                    //
//  programmed by Hitoshi Komatsu                                           //
//--------------------------------------------------------------------------//
//                      <<< Updated History >>>                             //
//--------------------------------------------------------------------------//
//  1998/11/25 | 쐬Jn                                                   //
//  2002/10/ 3 | jbg HitDCB  DCBObj ɕύX                     //
//**************************************************************************//
unit DCBObj;

interface

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses
  { Delphi }
  Windows, Classes;

type
  // csqt[䁄
  TDCBDtrControl = DTR_CONTROL_DISABLE..DTR_CONTROL_HANDSHAKE;
  {
    DTR_CONTROL_DISABLE     // foCX̃I[vDTRC𖳌ɂ ̂܂ܖԂۂ
    DTR_CONTROL_ENABLE      // foCX̃I[vDTRCLɂ ̂܂ܗLԂۂ
    DTR_CONTROL_HANDSHAKE   // DTR̃nhVFCNLɂ
  }

  // qsrt[䁄
  TDCBRtsControl = RTS_CONTROL_DISABLE..RTS_CONTROL_TOGGLE;
  {
    RTS_CONTROL_DISABLE     // foCX̃I[vRTSC𖳌ɂ ̂܂ܖԂۂ
    RTS_CONTROL_ENABLE      // foCX̃I[vRTSCLɂ ̂܂ܗLԂۂ
    RTS_CONTROL_HANDSHAKE   // RTS̃nhVFCNLɂ
    RTS_CONTROL_TOGGLE      // oCgf[^M̂߂ɗp\łꍇRTSCHxɂ邱Ƃw肷
  }

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   cba\̃bpNX                                             //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
  TDCBObject = class
  private
    function GetDWORD(Index: Integer): DWORD;
    procedure SetDWORD(Index: Integer; Value: DWORD);
    function GetFlags(Index: Integer): Boolean;
    procedure SetFlags(Index: Integer; Value: Boolean);
    function GetWORD(Index: Integer): WORD;
    procedure SetWORD(Index: Integer; Value: WORD);
    function GetBYTE(Index: Integer): BYTE;
    procedure SetBYTE(Index: Integer; Value: BYTE);
    function GetChar(Index: Integer): Char;
    procedure SetChar(Index: Integer; Value: Char);
    function GetDtrControl: TDCBDtrControl;
    procedure SetDtrControl(Value: TDCBDtrControl);
    function GetRtsControl: TDCBRtsControl;
    procedure SetRtsControl(Value: TDCBRtsControl);
  public
    FDCB: TDCB;
    constructor Create;
    property DCBlength: DWORD index 0 read GetDWORD write SetDWORD;
    property BaudRate: DWORD index 1 read GetDWORD write SetDWORD;
    property fBinary: Boolean index 0 read GetFlags write SetFlags;
    property fParity: Boolean index 1 read GetFlags write SetFlags;
    property fOutxCtsFlow: Boolean index 2 read GetFlags write SetFlags;
    property fOutxDsrFlow: Boolean index 3 read GetFlags write SetFlags;
    property fDtrControl: TDCBDtrControl read GetDtrControl write SetDtrControl;
    property fDsrSensitivity: Boolean index 4 read GetFlags write SetFlags;
    property fTXContinueOnXoff: Boolean index 5 read GetFlags write SetFlags;
    property fOutX: Boolean index 6 read GetFlags write SetFlags;
    property fInX: Boolean index 7 read GetFlags write SetFlags;
    property fErrorChar: Boolean index 8 read GetFlags write SetFlags;
    property fNull: Boolean index 9 read GetFlags write SetFlags;
    property fRtsControl: TDCBRtsControl  read GetRtsControl write SetRtsControl;
    property fAbortOnError: Boolean index 10 read GetFlags write SetFlags;
    property fDummy2: Boolean index 11 read GetFlags write SetFlags;
    property wReserved: WORD index 0 read GetWORD write SetWORD;
    property XonLim: WORD index 1 read GetWORD write SetWORD;
    property XoffLim: WORD index 2 read GetWORD write SetWORD;
    property ByteSize: BYTE index 0 read GetBYTE write SetBYTE;
    property Parity: BYTE index 1 read GetBYTE write SetBYTE;
    property StopBits: BYTE index 2 read GetBYTE write SetBYTE;
    property XonChar: Char index 0 read GetChar write SetChar;
    property XoffChar: Char index 1 read GetChar write SetChar;
    property ErrorChar: Char index 2 read GetChar write SetChar;
    property EofChar: Char index 3 read GetChar write SetChar;
    property EvtChar: Char index 4 read GetChar write SetChar;
    property wReserved1: WORD index 3 read GetWORD write SetWORD;
  end;



implementation

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   cba\̃bpNXF\bh̎                             //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//

//**************************************************************************//
//  Name      | TDCBObject.Create                                           //
//  Comment   | RXgN^                                              //
//**************************************************************************//
constructor TDCBObject.Create;
begin
  // Ƃ肠ONA
  FillChar(FDCB, SizeOf(FDCB), $00);
end;

//**************************************************************************//
//  Name      | TDCBObject.GetDWORD                                         //
//  Comment   | DWORD^f[^l̎擾                                       //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | 0 = sizeof(DCB)                                   //
//                  |   | 1 = {[[g                                    //
//--------------------------------------------------------------------------//
//  Result    | DWORD^l                                                   //
//**************************************************************************//
{$WARNINGS OFF}
function TDCBObject.GetDWORD(Index: Integer): DWORD;
begin
  case Index of
    0: Result := FDCB.DCBlength;  // sizeof(DCB)
    1: Result := FDCB.BaudRate;   // {[[g
  end;
end;
{$WARNINGS ON}

//**************************************************************************//
//  Name      | TDCBObject.SetDWORD                                         //
//  Comment   | DWORD^f[^l̐ݒ                                       //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | 0 = sizeof(DCB)                                   //
//                  |   | 1 = {[[g                                    //
//  Value           | I | ݒl                                            //
//**************************************************************************//
procedure TDCBObject.SetDWORD(Index: Integer; Value: DWORD);
begin
  case Index of
    0: FDCB.DCBlength := Value;   // sizeof(DCB)
    1: FDCB.BaudRate  := Value;   // {[[g
  end;
end;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx//
// rbg^̃}XNle[u                                               //
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx//
const
  FlagBits: array[0..11] of Longint = (
    $00000001,  // fBinaly
    $00000002,  // fParity
    $00000004,  // fOutxCtsFlow
    $00000008,  // fOutxDsrFlow
    $00000040,  // fDsrSensitivity
    $00000080,  // fTXContinueOnXoff
    $00000100,  // fOutX
    $00000200,  // fInX
    $00000400,  // fErrorChar
    $00000800,  // fNull
    $00004000,  // fAbortOnError
    $00008000); // fDummy2

//**************************************************************************//
//  Name      | TDCBObject.GetFlags                                         //
//  Comment   | Cӂ̃tOrbg̎擾                                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | FlagBitse[ũCfbNX                    //
//--------------------------------------------------------------------------//
//  Result    | rbgtOl                                              //
//**************************************************************************//
function TDCBObject.GetFlags(Index: Integer): Boolean;
begin
  Result := (FDCB.Flags and FlagBits[Index])<>0;
end;

//**************************************************************************//
//  Name      | TDCBObject.SetFlags                                         //
//  Comment   | Cӂ̃tOrbg̐ݒ                                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | FlagBitse[ũCfbNX                    //
//  Value           | I | ݒl                                            //
//**************************************************************************//
procedure TDCBObject.SetFlags(Index: Integer; Value: Boolean);
begin
  if Value then
    FDCB.Flags := FDCB.Flags or FlagBits[Index]
  else
    FDCB.Flags := FDCB.Flags and (not FlagBits[Index]);
end;

//**************************************************************************//
//  Name      | TDCBObject.GetDtrControl                                    //
//  Comment   | csqrbgQ̎擾                                    //
//--------------------------------------------------------------------------//
//  Result    | csqe                                              //
//**************************************************************************//
function TDCBObject.GetDtrControl: TDCBDtrControl;
begin
  Result := TDCBDtrControl((FDCB.Flags shr 4) and $00000003);
end;

//**************************************************************************//
//  Name      | TDCBObject.SetDtrControl                                    //
//  Comment   | csqrbgQ̐ݒ                                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Value           | I | ݒl                                            //
//**************************************************************************//
procedure TDCBObject.SetDtrControl(Value: TDCBDtrControl);
var
  MaskVal: DWORD;
begin
  MaskVal := DWORD(Ord(Value)) shl 4;
  FDCB.Flags := (FDCB.Flags and $FFFFFFCF) or MaskVal;
end;

//**************************************************************************//
//  Name      | TDCBObject.GetRtsControl                                    //
//  Comment   | qsrrbgQ̎擾                                    //
//--------------------------------------------------------------------------//
//  Result    | qsre                                              //
//**************************************************************************//
function TDCBObject.GetRtsControl: TDCBRtsControl;
begin
  Result := TDCBRtsControl((FDCB.Flags shr 12) and $00000003);
end;

//**************************************************************************//
//  Name      | TDCBObject.SetRtsControl                                    //
//  Comment   | qsrrbgQ̐ݒ                                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Value           | I | ݒl                                            //
//**************************************************************************//
procedure TDCBObject.SetRtsControl(Value: TDCBRtsControl);
var
  MaskVal: DWORD;
begin
  MaskVal := DWORD(Ord(Value)) shl 12;
  FDCB.Flags := (FDCB.Flags and $FFFFCFFF) or MaskVal;
end;

//**************************************************************************//
//  Name      | TDCBObject.GetWORD                                          //
//  Comment   | WORD^f[^l̎擾                                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | 0 = wReserved                                     //
//                  |   | 1 = XonLim                                        //
//                  |   | 2 = XoffLim                                       //
//                  |   | 3 = wReserved1                                    //
//--------------------------------------------------------------------------//
//  Result    | WORD^l                                                    //
//**************************************************************************//
{$WARNINGS OFF}
function TDCBObject.GetWORD(Index: Integer): WORD;
begin
  case Index of
    0: Result := FDCB.wReserved;    // o[Wł͎gȂ
    1: Result := FDCB.XonLim;       // MɂXONXbVh
    2: Result := FDCB.XoffLim;      // MɂXOFFXbVh
    3: Result := FDCB.wReserved1;   //
  end;
end;
{$WARNINGS ON}

//**************************************************************************//
//  Name      | TDCBObject.SetWORD                                          //
//  Comment   | WORD^f[^l̐ݒ                                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | 0 = wReserved                                     //
//                  |   | 1 = XonLim                                        //
//                  |   | 2 = XoffLim                                       //
//                  |   | 3 = wReserved1                                    //
//  Value           | I | ݒl                                            //
//**************************************************************************//
procedure TDCBObject.SetWORD(Index: Integer; Value: WORD);
begin
  case Index of
    0: FDCB.wReserved  := Value;    // o[Wł͎gȂ
    1: FDCB.XonLim     := Value;    // MɂXONXbVh
    2: FDCB.XoffLim    := Value;    // MɂXOFFXbVh
    3: FDCB.wReserved1 := Value;    //
  end;
end;

//**************************************************************************//
//  Name      | TDCBObject.GetBYTE                                          //
//  Comment   | BYTE^f[^l̎擾                                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | 0 = ByteSize                                      //
//                  |   | 1 = Parity                                        //
//                  |   | 2 = StopBits                                      //
//--------------------------------------------------------------------------//
//  Result    | BYTE^l                                                    //
//**************************************************************************//
{$WARNINGS OFF}
function TDCBObject.GetBYTE(Index: Integer): BYTE;
begin
  case Index of
    0: Result := FDCB.ByteSize;     // oCg̃rbg (4`8)
    1: Result := FDCB.Parity;       // peB  0=Ȃ 1= 2= 3=}[N 4=
    2: Result := FDCB.StopBits;     // Xgbvrbg  0 1 2 = 1 1.5 2
  end;
end;
{$WARNINGS ON}

//**************************************************************************//
//  Name      | TDCBObject.SetBYTE                                          //
//  Comment   | BYTE^f[^l̐ݒ                                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | 0 = ByteSize                                      //
//                  |   | 1 = Parity                                        //
//                  |   | 2 = StopBits                                      //
//  Value           | I | ݒl                                            //
//**************************************************************************//
procedure TDCBObject.SetBYTE(Index: Integer; Value: BYTE);
begin
  case Index of
    0: FDCB.ByteSize := Value;      // oCg̃rbg (4`8)
    1: FDCB.Parity   := Value;      // peB  0=Ȃ 1= 2= 3=}[N 4=
    2: FDCB.StopBits := Value;      // Xgbvrbg  0 1 2 = 1 1.5 2
  end;
end;

//**************************************************************************//
//  Name      | TDCBObject.GetChar                                          //
//  Comment   | Char^f[^l̎擾                                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | 0 = XonChar                                       //
//                  |   | 1 = XoffChar                                      //
//                  |   | 2 = ErrorChar                                     //
//                  |   | 3 = EofChar                                       //
//                  |   | 4 = EvtChar                                       //
//--------------------------------------------------------------------------//
//  Result    | Char^l                                                    //
//**************************************************************************//
{$WARNINGS OFF}
function TDCBObject.GetChar(Index: Integer): Char;
begin
  case Index of
    0: Result := FDCB.XonChar;      // MюMɑ΂XON
    1: Result := FDCB.XoffChar;     // MюMɑ΂XOFF
    2: Result := FDCB.ErrorChar;    // G[u
    3: Result := FDCB.EofChar;      // ͕̏I
    4: Result := FDCB.EvtChar;      // 󂯎Cxg
  end;
end;
{$WARNINGS ON}

//**************************************************************************//
//  Name      | TDCBObject.SetChar                                          //
//  Comment   | Char^f[^l̐ݒ                                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Index           | I | 0 = XonChar                                       //
//                  |   | 1 = XoffChar                                      //
//                  |   | 2 = ErrorChar                                     //
//                  |   | 3 = EofChar                                       //
//                  |   | 4 = EvtChar                                       //
//  Value           | I | ݒl                                            //
//**************************************************************************//
procedure TDCBObject.SetChar(Index: Integer; Value: Char);
begin
  case Index of
    0: FDCB.XonChar   := Value;     // MюMɑ΂XON
    1: FDCB.XoffChar  := Value;     // MюMɑ΂XOFF
    2: FDCB.ErrorChar := Value;     // G[u
    3: FDCB.EofChar   := Value;     // ͕̏I
    4: FDCB.EvtChar   := Value;     // 󂯎Cxg
  end;
end;



end.
