//**************************************************************************//
//  Product     | AnobPʐMR|[lguAlohaPC1CommXv           //
//  Version     | 1.00 (Build 0)                                            //
//--------------------------------------------------------------------------//
//  Unit        | IAlohaPC1CommX NX ("NDAlohaPC1.AlohaPC1CommX")    //
//--------------------------------------------------------------------------//
//  File Name   | AlohaPC1CommX.pas                                         //
//  Platform    | Windows 2000                                              //
//  Compiler    | Delphi5,6                                                 //
//  Last Update | 2008/10/30                                                //
//--------------------------------------------------------------------------//
//  Copyright (c) 2002 Hitwareland Corporation.                             //
//  All rights reserved.                                                    //
//  programmed by Hitoshi Komatsu                                           //
//--------------------------------------------------------------------------//
//                      <<< Updated History >>>                             //
//--------------------------------------------------------------------------//
//  2002/10/ 9 | 쐬Jn                                                   //
//       10/11 | "TRIAL_EDITION" V{`ărh邱ƂɂA   //
//             | gCAł悤ɑΉB                         //
//             | FindPort \bh̒ǉ                                    //
//       10/12 | gCAł̏ꍇɁA_CAOoȂŎp     //
//             | ݂đΉ悤ɕύXB                             //
//             | ERRCD_PORT_NOT_FOUND G[R[h̒ǉB                  //
//       10/28 | PortName vpeBlݒO FLastError NA -    //
//             | Ȃ_CB                                   //
//             | TAlohaPC1Comm R|[lg̕ύXɂCB             //
//       12/25 | Delphi5 ւ̑Ή                                           //
//  2008/10/30 | gCAŃR[hiRgj̍폜                   //
//**************************************************************************//
unit AlohaPC1CommX;

{$ifndef VER130} // not D5
{$WARN SYMBOL_PLATFORM OFF}
{$endif}

interface

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses
  { Delphi }
  ComObj, ActiveX, AxCtrls, Classes, StdVcl, Windows, Messages, Contnrs, SyncObjs,
  SysUtils,

  { Hitwareland VCL }
  AlohaPC1Comm,

  { This Project }
  NDAAlohaPC1_TLB, PhoneNumber, Logger;

type
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   Cxg񓯊spCxgf[^NX                             //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
  TEventType = (
    etOnPhoneDetect,
    etOnCommError,
    etOnError);

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   "NDAlohaPC1.AlohaPC1CommX" AnobPʐMNX                    //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
  TAlohaPC1CommX = class(TAutoObject, IConnectionPointContainer, IAlohaPC1CommX)
  private
    { Private 錾 }
    FConnectionPoints: TConnectionPoints;
    FConnectionPoint: TConnectionPoint;
    FEvents: IAlohaPC1CommXEvents;
    { FFEvents ̓CxgVNǗł܂B̃Cxg
      VNɃANZXɂ FConnectionPoint.SinkList g܂B}
    FAlohaPC1Comm: TAlohaPC1Comm;       // ʐMR|[lg
    FLastError: Integer;                // vpeBA\bhs̃G[R[hiERRCD_*** QƁj
    procedure DoPhoneDetect(Sender: TAlohaPC1Comm;
     const Packet: TPhoneNumberPacket);
    procedure DoCommError(Sender: TAlohaPC1Comm; dwError: DWORD);
    procedure DoError(Sender: TAlohaPC1Comm; const Msg: string);
    procedure DoAsyncCommError(Sender: TAlohaPC1Comm; dwError: DWORD);
    procedure DoAsyncError(Sender: TAlohaPC1Comm; const Msg: string);
    procedure DoAsyncTrace(Sender: TAlohaPC1Comm; const Msg: string; Win32ErrCode: DWORD);
    procedure ADDLOG(const Msg: string; LogType: TLogType);
  public
    procedure Initialize; override;
  protected
    { Protected 錾 }
    property ConnectionPoints: TConnectionPoints read FConnectionPoints
      implements IConnectionPointContainer;
    procedure EventSinkChanged(const EventSink: IUnknown); override;
    function Get_Active: WordBool; safecall;
    function Get_PortName: WideString; safecall;
    function ReadMemory(Addr: Smallint;
      out PhoneNumber: IPhoneNumber): WordBool; safecall;
    procedure Set_Active(Value: WordBool); safecall;
    procedure Set_PortName(const Value: WideString); safecall;
    procedure Close; safecall;
    function Open: WordBool; safecall;
    function WriteMemory(const Number: WideString): WordBool; safecall;
    function Get_LastError: Integer; safecall;
    function FindPort: WordBool; safecall;
    function ReadMemory2(Addr: Smallint): IPhoneNumber; safecall;
  public
    destructor Destroy; override;
  end;

implementation

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses ComServ;

const
  CM_ANYEVENT = WM_USER + $101;
  ID_ANYEVENT = $12345678;

  // eG[R[h
  ERRCD_NOERROR        = 0;             // G[Ȃ
  ERRCD_CAN_NOT_OPEN   = 1;             // I[vłȂiCreateFilej
  ERRCD_DONE_OPENED    = 2;             // I[vĂ邽ߗv͎󂯕tȂ
  ERRCD_DO_NOT_OPEN    = 3;             // I[vĂȂ
  ERRCD_CTS_OFF        = 4;             // bsribrjneê߂q^vłȂ
  ERRCD_READMEM_ERROR  = 5;             // ERRCD_CTS_OFF ȊO ReadMemory G[
  ERRCD_WRITEMEM_ERROR = 6;             // ERRCD_CTS_OFF ȊO WriteMemory G[
  ERRCD_PORT_NOT_FOUND = 7;             // FindPort \bhɂĐڑ|[gȂ
  ERRCD_INTERNAL       = -1;            // G[
  //ERRCD_TRIAL_EXPIRED  = -2;            // po߂igCAł̂݁j


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   "NDAlohaPC1.AlohaPC1CommX" AnobPʐMNXF\bh̎    //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//

//**************************************************************************//
//  Name      | TAlohaPC1CommX.ADDLOG                                       //
//  Comment   | Ȍo                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | Of[^                                        //
//  LogLevel        | I | Õ^Cv                                      //
//**************************************************************************//
procedure TAlohaPC1CommX.ADDLOG(const Msg: string; LogType: TLogType);
var
  ObjMsg: string;
begin
  ObjMsg := Format('[$%s] %s', [IntToHex(Integer(Self), 8), Msg]);
  Logger.ADDLOG(ObjMsg, LogType);
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.EventSinkChanged                             //
//  Comment   |                                                             //
//**************************************************************************//
procedure TAlohaPC1CommX.EventSinkChanged(const EventSink: IUnknown);
begin
  FEvents := EventSink as IAlohaPC1CommXEvents;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Initialize                                   //
//  Comment   | [`iRXgN^ɑΉj                      //
//--------------------------------------------------------------------------//
//  Note      | OvO{NX̃IuWFNg쐬ۂɂ    //
//            | TAlohaPC1CommX.Create RXgN^͌Ă΂Ȃ -          //
//            | iĂяoȂj߁Ã\bhɖ{RXgN -  //
//            | sLqB                                        //
//**************************************************************************//
procedure TAlohaPC1CommX.Initialize;
begin
  ADDLOG('IAlohaPC1CommX IuWFNg', logTRACE);

  inherited Initialize; { TAutoObject.Initialize }
  FConnectionPoints := TConnectionPoints.Create(Self);
  if AutoFactory.EventTypeInfo <> nil then
    FConnectionPoint := FConnectionPoints.CreateConnectionPoint(
      AutoFactory.EventIID, ckSingle, EventConnect)
  else FConnectionPoint := nil;

  // AnobPʐMR|[lg̐ݒ
  FAlohaPC1Comm := TAlohaPC1Comm.Create(nil);
  with FAlohaPC1Comm do begin
    AsyncHandling := False; // XbhĂяoɂ
    OnPhoneDetect := DoPhoneDetect;
    OnCommError   := DoCommError;
    OnError       := DoError;
    OnAsyncCommError := DoAsyncCommError;
    OnAsyncError     := DoAsyncError;
    OnAsyncTrace     := DoAsyncTrace;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Destroy                                      //
//  Comment   | fXgN^                                                //
//**************************************************************************//
destructor TAlohaPC1CommX.Destroy;
begin
  ADDLOG('IAlohaPC1CommX IuWFNgp', logTRACE);

  // AnoPʐMR|[lg̔p
  FAlohaPC1Comm.Free;

  inherited; { TComObject.Destroy }
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Get_Active                                   //
//  Comment   | Active vpeB getter \bh                         //
//--------------------------------------------------------------------------//
//  Result    | Active p[^l                                         //
//**************************************************************************//
function TAlohaPC1CommX.Get_Active: WordBool;
begin
  Result := FAlohaPC1Comm.Active;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Set_Active                                   //
//  Comment   | Active vpeB setter \bh                         //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Value           | I | Active p[^l                               //
//--------------------------------------------------------------------------//
//  Note      | ɐݒłǂ LastError vpeBQƂB //
//**************************************************************************//
procedure TAlohaPC1CommX.Set_Active(Value: WordBool);
begin
  // OAG[ Open, Close \bhōs킹
  if FAlohaPC1Comm.Active <> Value then begin
    if Value then
      Open
    else
      Close;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Get_PortName                                 //
//  Comment   | PortName vpeB getter \bh                       //
//--------------------------------------------------------------------------//
//  Result    | PortName p[^l                                       //
//**************************************************************************//
function TAlohaPC1CommX.Get_PortName: WideString;
begin
  Result := WideString(FAlohaPC1Comm.PortName);
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Set_PortName                                 //
//  Comment   | PortName vpeB setter \bh                       //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Value           | I | PortName p[^l                             //
//--------------------------------------------------------------------------//
//  Note      | ɐݒłǂ LastError vpeBQƂB //
//**************************************************************************//
procedure TAlohaPC1CommX.Set_PortName(const Value: WideString);
begin
  FLastError := ERRCD_NOERROR; // G[ԉi2002/10/28 ǉj
  try
    FAlohaPC1Comm.PortName := string(Value);
  except
    on E: Exception do begin
      FLastError := ERRCD_DONE_OPENED; // I[v̂ߕύXs
      ADDLOG('IAlohaPC1CommX.Port ݒG[: ' + E.Message, logERROR);
    end;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Open                                         //
//  Comment   | ʐMI[v                                            //
//--------------------------------------------------------------------------//
//  Result    | True  = I[vłA܂͊ɃI[vĂ          //
//            | False = I[vłȂ                                    //
//**************************************************************************//
function TAlohaPC1CommX.Open: WordBool;
begin
  FLastError := ERRCD_NOERROR; // G[ԉ
  try
    FAlohaPC1Comm.Open;
    Result := True;
  except
    on E: Exception do begin
      FLastError := ERRCD_CAN_NOT_OPEN;
      Result := False;
      ADDLOG('IAlohaPC1CommX.Open G[: ' + E.Message, logERROR);
    end;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Close                                        //
//  Comment   | ʐMN[Y                                            //
//**************************************************************************//
procedure TAlohaPC1CommX.Close;
begin
  FLastError := ERRCD_NOERROR; // G[ԉ
  try
    FAlohaPC1Comm.Close;
  except
    on E: Exception do begin
      FLastError := ERRCD_INTERNAL; // G[
      ADDLOG('IAlohaPC1CommX.Close G[: ' + E.Message, logERROR);
    end;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.ReadMemory                                   //
//  Comment   | AnobP̃ǂݏo                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Addr            | I | AhXi1 ` 30j                         //
//  PhoneNumber     | O | ǂݏodbԍf[^                          //
//                  |   | G[̏ꍇ̓ZbgȂ_ɒ                //
//--------------------------------------------------------------------------//
//  Result    | True = ɓǂݏo  False = G[                     //
//**************************************************************************//
function TAlohaPC1CommX.ReadMemory(Addr: Smallint;
  out PhoneNumber: IPhoneNumber): WordBool;
var
  Packet: TPhoneNumberPacket;
begin
  FLastError := ERRCD_NOERROR; // G[ԉ
  Result := False;
  try
    FAlohaPC1Comm.ReadMemory(Addr, Packet);
    PhoneNumber := TPhoneNumber.Create(Packet);
    Result := True;
  except
    on E: EAlohaPC1CommError do begin
      ADDLOG(Format('AlohaPC1CommX.ReadMemory G[: %s (ErrorCode=$%X Win32ErrCode=%d)',
       [E.Message, E.ErrorCode, E.Win32ErrCode]), logERROR);
      case E.ErrorCode of
        // I[vĂȂ
        CAPC1ERR_DO_NOT_OPEN: FLastError := ERRCD_DO_NOT_OPEN;
        // bsribrjneê߂q^vłȂ
        CAPC1ERR_CTS_OFF: FLastError := ERRCD_CTS_OFF;
        // LȊÕG[
        else              FLastError := ERRCD_READMEM_ERROR;
      end;
    end;
    on E: Exception do begin
      ADDLOG('AlohaPC1CommX.ReadMemory G[: ' + E.Message, logERROR);
      FLastError := ERRCD_INTERNAL;
    end;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.ReadMemory2                                  //
//  Comment   | AnobP̃ǂݏoiVBScript Ήpj           //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Addr            | I | AhXi1 ` 30j                         //
//  PhoneNumber     | O | ǂݏodbԍf[^                          //
//                  |   | G[̏ꍇ̓ZbgȂ_ɒ                //
//--------------------------------------------------------------------------//
//  Result    | ǂݏodbԍf[^                                    //
//--------------------------------------------------------------------------//
//  Exception | G[̏ꍇ͗O𓊂                                  //
//            | Delphi ̏ꍇ͂̃\bhĂяo EOleException     //
//            | B                                                //
//            | VB, VBScript ̏ꍇ͌ĂяoƂ Error IuWFNg    //
//            | G[eݒ肳B                                    //
//**************************************************************************//
function TAlohaPC1CommX.ReadMemory2(Addr: Smallint): IPhoneNumber;
var
  Packet: TPhoneNumberPacket;
begin
  FLastError := ERRCD_NOERROR; // G[ԉ
  try
    FAlohaPC1Comm.ReadMemory(Addr, Packet);
    Result := TPhoneNumber.Create(Packet);
  except
    on E: EAlohaPC1CommError do begin
      ADDLOG(Format('AlohaPC1CommX.ReadMemory G[: %s (ErrorCode=$%X Win32ErrCode=%d)',
       [E.Message, E.ErrorCode, E.Win32ErrCode]), logERROR);
      case E.ErrorCode of
        // I[vĂȂ
        CAPC1ERR_DO_NOT_OPEN: FLastError := ERRCD_DO_NOT_OPEN;
        // bsribrjneê߂q^vłȂ
        CAPC1ERR_CTS_OFF: FLastError := ERRCD_CTS_OFF;
        // LȊÕG[
        else              FLastError := ERRCD_READMEM_ERROR;
      end;
      raise; // Ođ
    end;
    on E: Exception do begin
      ADDLOG('AlohaPC1CommX.ReadMemory G[: ' + E.Message, logERROR);
      FLastError := ERRCD_INTERNAL;
      raise; // Ođ
    end;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.WriteMemory                                  //
//  Comment   | AnobP̃o                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Number          | I | ݒ肷dbԍ                                  //
//--------------------------------------------------------------------------//
//  Result    | True = ɏo  False = G[                     //
//**************************************************************************//
function TAlohaPC1CommX.WriteMemory(const Number: WideString): WordBool;
begin
  FLastError := ERRCD_NOERROR; // G[ԉ
  Result := False;
  try
    FAlohaPC1Comm.WriteMemory(string(Number));
    Result := True;
  except
    on E: EAlohaPC1CommError do begin
      ADDLOG(Format('AlohaPC1CommX.WriteMemory G[: %s (ErrorCode=$%X Win32ErrCode=%d)',
       [E.Message, E.ErrorCode, E.Win32ErrCode]), logERROR);
      case E.ErrorCode of
        // I[vĂȂ
        CAPC1ERR_DO_NOT_OPEN: FLastError := ERRCD_DO_NOT_OPEN;
        // bsribrjneê߂q^vłȂ
        CAPC1ERR_CTS_OFF: FLastError := ERRCD_CTS_OFF;
        // LȊÕG[
        else              FLastError := ERRCD_WRITEMEM_ERROR;
      end;
    end;
    on E: Exception do begin
      ADDLOG('AlohaPC1CommX.WriteMemory G[: ' + E.Message, logERROR);
      FLastError := ERRCD_INTERNAL;
    end;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.DoPhoneDetect                                //
//  Comment   | OnPhoneDetect Cxg                                  //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | FAlohaPC1Comm                                     //
//  Packet          | I | dbԍf[^                                    //
//**************************************************************************//
procedure TAlohaPC1CommX.DoPhoneDetect(Sender: TAlohaPC1Comm;
 const Packet: TPhoneNumberPacket);
var
  S: string;
  PhoneNumber: IPhoneNumber;
begin
  SetLength(S, 20);
  Move(Packet.Number, PChar(S)^, 20);
  ADDLOG(Format('OnPhoneDetect: "%s"', [S]), logTRACE);
  if FEvents <> nil then begin
    PhoneNumber := TPhoneNumber.Create(Packet);
    FEvents.OnPhoneDetect(PhoneNumber);
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.DoCommError                                  //
//  Comment   | OnCommError Cxg                                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | FAlohaPC1Comm                                     //
//  dwError         | I | G[liClearCommErrorj                    //
//**************************************************************************//
procedure TAlohaPC1CommX.DoCommError(Sender: TAlohaPC1Comm; dwError: DWORD);
begin
  if FEvents <> nil then
    FEvents.OnCommError(dwError);
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.DoError                                      //
//  Comment   | OnError Cxg                                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | FAlohaPC1Comm                                     //
//  Msg             | I | OIuWFNg̃bZ[WXgO            //
//**************************************************************************//
procedure TAlohaPC1CommX.DoError(Sender: TAlohaPC1Comm; const Msg: string);
begin
  if FEvents <> nil then
    FEvents.OnError(WideString(Msg));
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.DoAsyncCommError                             //
//  Comment   | OnAsyncCommError Cxg                               //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | FAlohaPC1Comm                                     //
//  dwError         | I | G[liClearCommErrorj                    //
//--------------------------------------------------------------------------//
//  Note      | ̃\bh͊ĎXbh񓯊IɌĂяoB      //
//**************************************************************************//
procedure TAlohaPC1CommX.DoAsyncCommError(Sender: TAlohaPC1Comm; dwError: DWORD);
begin
  ADDLOG(Format('OnAsyncCommError: ʐMG[ (0x%X)', [dwError]), logERROR);
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.DoAsyncError                                 //
//  Comment   | OnAsyncError Cxg                                   //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | FAlohaPC1Comm                                     //
//  Msg             | I | OIuWFNg̃bZ[WXgO            //
//--------------------------------------------------------------------------//
//  Note      | ̃\bh͊ĎXbh񓯊IɌĂяoB      //
//**************************************************************************//
procedure TAlohaPC1CommX.DoAsyncError(Sender: TAlohaPC1Comm; const Msg: string);
begin
  ADDLOG(Format('OnAsyncError: %s', [Msg]), logERROR);
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.DoAsyncTrace                                 //
//  Comment   | OnAsyncTrace Cxg                                   //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Sender          | I | FAlohaPC1Comm                                     //
//  Msg             | I | g[XbZ[W                                //
//  Win32ErrCode    | I | Win32 API sG[ GetLastError l          //
//                  |   | i0 ̏ꍇ Win32 API ĂяoĂȂj       //
//--------------------------------------------------------------------------//
//  Note      | ̃\bh͊ĎXbh񓯊IɌĂяoB      //
//**************************************************************************//
procedure TAlohaPC1CommX.DoAsyncTrace(Sender: TAlohaPC1Comm; const Msg: string;
 Win32ErrCode: DWORD);
begin
  if Win32ErrCode = 0 then
    ADDLOG(Msg, logTRACE)
  else
    ADDLOG(Format('%s (Win32ErrCode=%d)', [Msg, Win32ErrCode]), logERROR);
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Get_LastError                                //
//  Comment   | vpeBA\bhs̍ŏIG[R[h            //
//--------------------------------------------------------------------------//
//  Result    | G[R[hiERRCD_*** QƁj                              //
//**************************************************************************//
function TAlohaPC1CommX.Get_LastError: Integer;
begin
  Result := FLastError;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.FindPort                                     //
//  Comment   | AnobPɐڑĂbnl|[gTāA          //
//            | PortName vpeBɃZbg                             //
//--------------------------------------------------------------------------//
//  Result    | True  = ڑĂbnl|[gA              //
//            |         PortName vpeBɃZbgB                   //
//            | False = ڑĂbnl|[gȂA      //
//            |         ܂ Open Ă邽߁APortName vpeB   //
//            |         ݒłȂԂłB                            //
//**************************************************************************//
function TAlohaPC1CommX.FindPort: WordBool;
var
  CommPorts: TStringList;
begin
  FLastError := ERRCD_NOERROR; // G[ԉ
  Result := False;
  if FAlohaPC1Comm.Active then begin
    FLastError := ERRCD_DONE_OPENED; // I[v̂ߕύXs
    ADDLOG('IAlohaPC1CommX.FindPort G[: I[v̂ߎsł܂B', logERROR);
  end
  else begin
    try
      CommPorts := TStringList.Create;
      try
        // ׂĂ̂bnl|[gXLāAŏɌ|[gZbg
        ScanAlohaPC1Ports(CommPorts, False);
        Result := CommPorts.Count >= 1;
        if Result then begin
          FAlohaPC1Comm.PortName := CommPorts[0];
          ADDLOG('AnobP ' + CommPorts[0] + ' |[gɐڑĂ܂B', logTRACE);
        end
        else begin
          ADDLOG('AnobP̐ڑ|[g͌܂łB', logTRACE);
          FLastError := ERRCD_PORT_NOT_FOUND;
        end;
      finally
        CommPorts.Free;
      end;
    except
      on E: Exception do begin
        ADDLOG('AlohaPC1CommX.FindPort G[: ' + E.Message, logERROR);
        FLastError := ERRCD_INTERNAL;
        Result := False;
      end;
    end;
  end;
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//                                                              //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
initialization
  TAutoObjectFactory.Create(ComServer, TAlohaPC1CommX, Class_AlohaPC1CommX,
    ciMultiInstance, tmApartment);
end.
