//**************************************************************************//
//  Product     | AnobPʐMR|[lguAlohaPC1CommXv           //
//  Version     | 1.00 (Build 0)                                            //
//--------------------------------------------------------------------------//
//  Unit        | IPhoneNumner NX ("NDAlohaPC1.LoggingController")  //
//--------------------------------------------------------------------------//
//  File Name   | LoggingController.pas                                     //
//  Platform    | Windows 2000                                              //
//  Compiler    | Delphi5,6                                                 //
//  Last Update | 2002/12/25                                                //
//--------------------------------------------------------------------------//
//  Copyright (c) 2002 Hitwareland Corporation.                             //
//  All rights reserved.                                                    //
//  programmed by Hitoshi Komatsu                                           //
//--------------------------------------------------------------------------//
//                      <<< Updated History >>>                             //
//--------------------------------------------------------------------------//
//  2002/10/ 9 | 쐬Jn                                                   //
//       12/25 | Delphi5 ւ̑Ή                                           //
//**************************************************************************//
unit LoggingController;

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx//
// ̃NXiIuWFNgj̓Ap[ggXbhAt[Xbhp - //
// łBgƂ ASP  Application IuWFNgɊi[Ă     //
// ǂ̃NGXgXbhłgƂłB                         //
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx//

{$ifndef VER130} // not D5
{$WARN SYMBOL_PLATFORM OFF}
{$endif}

interface

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses
  { Delphi }
  ComObj, ActiveX, StdVcl, SysUtils,

  { This Project }
  NDAAlohaPC1_TLB, Logger;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   "NDAlohaPC1.LoggingController" MORg[NX            //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
type
  TLoggingController = class(TAutoObject, ILoggingController)
  protected
    function Get_Enabled: WordBool; safecall;
    function Get_LogFileName: WideString; safecall;
    procedure AddLog(const Msg: WideString); safecall;
    procedure Set_Enabled(Value: WordBool); safecall;
    procedure Set_LogFileName(const Value: WideString); safecall;
    { Protected 錾 }
  public
    procedure Initialize; override;
    destructor Destroy; override;
  end;

implementation

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses ComServ;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   "NDAlohaPC1.LoggingController" MORg[NX            //
//     F\bh̎                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//

//**************************************************************************//
//  Name      | TLoggingController.Initialize                               //
//  Comment   | [`iRXgN^ɑΉj                      //
//--------------------------------------------------------------------------//
//  Note      | OvO{NX̃IuWFNg쐬ۂɂ    //
//            | TLoggingController.Create RXgN^ -                //
//            | Ă΂ȂiĂяoȂj߁Ã\bh -          //
//            | {RXgNōsLqB                      //
//**************************************************************************//
procedure TLoggingController.Initialize;
var
  ObjMsg: string;
begin
  ObjMsg := Format('[$%s] ILoggingController IuWFNg', [IntToHex(Integer(Self), 8)]);
  Logger.ADDLOG(ObjMsg, logTRACE);

  inherited; { TAutoObject.Initialize }
end;

//**************************************************************************//
//  Name      | TLoggingController.Destroy                                  //
//  Comment   | fXgN^                                                //
//**************************************************************************//
destructor TLoggingController.Destroy;
var
  ObjMsg: string;
begin
  ObjMsg := Format('[$%s] ILoggingController IuWFNgp', [IntToHex(Integer(Self), 8)]);
  Logger.ADDLOG(ObjMsg, logTRACE);

  inherited; { TComObject.Destroy }
end;

//**************************************************************************//
//  Name      | TLoggingController.Get_Enabled                              //
//  Comment   | Oo͂LɂȂĂ邩ǂ                          //
//--------------------------------------------------------------------------//
//  Result    | True = Oo͗L  False = Oo͖                   //
//**************************************************************************//
function TLoggingController.Get_Enabled: WordBool;
begin
  Result := _Logger.Enabled;
end;

//**************************************************************************//
//  Name      | TAlohaPC1CommX.Set_Enabled                                  //
//  Comment   | Oo̗͂L^̐ݒ                                  //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Value           | I | True = Lɂ  False = ɂ             //
//**************************************************************************//
procedure TLoggingController.Set_Enabled(Value: WordBool);
begin
  _Logger.Enabled := Value;
end;

//**************************************************************************//
//  Name      | TLoggingController.Get_LogFileName                          //
//  Comment   | ݂̃Of[^o͐t@C̎擾                      //
//--------------------------------------------------------------------------//
//  Result    | Oo̓t@C                                          //
//**************************************************************************//
function TLoggingController.Get_LogFileName: WideString;
begin
  Result := WideString(_Logger.FileName);
end;

//**************************************************************************//
//  Name      | TLoggingController.Set_LogFileName                          //
//  Comment   | Of[^o͐t@C̐ݒύX                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Value           | I | ݒ肷t@C                                //
//**************************************************************************//
procedure TLoggingController.Set_LogFileName(const Value: WideString);
begin
  _Logger.FileName := string(Value);
end;

//**************************************************************************//
//  Name      | TLoggingController.AddLog                                   //
//  Comment   | RgȌo                                          //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | Rg                                          //
//**************************************************************************//
procedure TLoggingController.AddLog(const Msg: WideString);
begin
  // RgȌo
  Logger.ADDLOG(string(Msg), logCOMMENT);
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//                                                              //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
initialization
  // Ap[ggXbhAt[Xbhp
  TAutoObjectFactory.Create(ComServer, TLoggingController, Class_LoggingController,
    ciMultiInstance, tmBoth);
end.
