//**************************************************************************//
//  Unit        | AnobPʐMR|[lg                            //
//  Version     | 1.00                                                      //
//--------------------------------------------------------------------------//
//  File Name   | AlohaPC1Com.pas                                           //
//  Platform    | Windows2000                                               //
//  Compiler    | Delphi5,6                                                 //
//  Last Update | 2013/ 4/19                                                //
//--------------------------------------------------------------------------//
//  Copyright (c) 2002 Hitwareland Corporation.                             //
//  All rights reserved.                                                    //
//  programmed by Hitoshi Komatsu                                           //
//--------------------------------------------------------------------------//
//                      <<< Updated History >>>                             //
//--------------------------------------------------------------------------//
//  2002/ 9/15 | 쐬Jn                                                   //
//       10/ 9 | TAlohaPC1Comm.TRACE ꕔύXB                   //
//             | TAlohaPC1Comm.DoCtsChanged_Thread ɂĎMG[   //
//             | Mobt@NA悤ɂB                     //
//             | ǂݏoR}h̃AhXw̏ʌƉʌt //
//             | ȂĂoOCB                                     //
//       10/10 | OnAsyncExceptioon  OnError ɕύX                        //
//       10/11 | ScanAlohaPC1Ports ֐̒ǉ                               //
//             | TAlohaPC1Comm.ReadMemory gđSAhXǂݏoȂ  //
//             | ꍇɁAxUDRbx|Ă߁ASleep l   //
//             | 悤ɂđxAbv}B                     //
//             |i݂͂RDRbxɂȂ on PenIII750MHzj              //
//       10/28 | RȌꍇ́A܂ĂȂ -     //
//             | AhXǂݏoƓׂ͂ "9" ɁAdbԍׂ͂  //
//             | 󔒁i" "jɂȂB̃RgǉB                //
//             | OnError, OnCommError nhݒ肵ĂȂƃ_CAO  //
//             | \悤ɂĂAScanAlohaPC1Ports ֐       //
//             | _CAO\Ƃ܂߁A\Ȃ悤ɂB //
//       10/30 | ĎXbh̃CxgĂяo@ɂāA       //
//             | TThread.Synchronize gĂAActiveX Ŏg       //
//             | ߂ĂȂȂ邽߁APostMessage g悤ɕύXB   //
//             | OnError  Exception IuWFNgp[^G[        //
//             | bZ[WXgOp[^ɕύXB                 //
//             | OnAsyncCommError, OnAsyncError, OnTrace CxgǉB   //
//       11/ 9 | AlohaPC1Comm.dcr \[X̒ǉ                            //
//       12/25 | Delphi5 ւ̑Ή                                           //
//  2010/ 4/22 | |[gCOM10ȍ~̏ꍇɃG[ɂȂs̏CB        //
//        6/21 | |[gI[vRTSONɂ悤ɂB                //
//             | R/WƒMŃtOgĔr䂷悤 -//
//             | ǉB                                                 //
//        7/ 8 | M̏CB                                   //
//             | AnUSBhCoUSBVAϊA_v^̃hCo     //
//             | sxz悤ȏꂽB               //
//        7/ 9 | TAlohaPC1Comm.Check2ndPacket vpeBǉB        //
//  2013/ 4/19 | Windows7ɂāAProlificŐVhCogƃAn //
//             | ǂݍ݂łȂsɑΉB                         //
//**************************************************************************//
unit AlohaPC1Comm;

interface

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses
  { Delphi }
  Windows, Messages, SysUtils, Classes, SyncObjs, Registry,

{$IFDEF VER130} // D5
  // AllocateHWnd, DeallocateHWnd
  Forms,
{$ENDIF}


  { Hitwareland }
  DCBObj;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   AnobPʐMR|[lgNX                                 //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
type
  PPhoneNumberPacket = ^TPhoneNumberPacket;
  TPhoneNumberPacket = packed record
    case Integer of
      0: (
        Data: array[0..30] of Char);
      1: (
        STX: Char;                    // STX = #02
        Date: array[0..8] of Char;    // MiȂꍇׂ͂ "9"j
        Number: array[0..19] of Char; // dbԍiȂꍇׂ͂ċ󔒁j
        ETX: Char);                   // ETX = #03
      2: (
        _stx: Char;
        Month: array[0..1] of Char;   // i"01" ` "12"j
        Day: array[0..1] of Char;     // i"01" ` "31"j
        DayOfWeek: Char;              // ji"00": ` "06":yj
        Hour: array[0..1] of Char;    // i"00" ` "23"j
        Minute: array[0..1] of Char;  // i"00" ` "59"j
        NumberType: Char;             // "P":ʒm "O" or "S":\O "C":Odb "E":G[ :dbԍ :Ȃ
        _num2: array[0..18] of Char;
        _etx: Char);
  end;
const
  PHONE_NUMBER_PACKET_SIZE = SizeOf(TPhoneNumberPacket); // RPoCg
type
  TAlohaPC1Comm = class;
  TPhoneDetectEvent = procedure(Sender: TAlohaPC1Comm; const Packet: TPhoneNumberPacket) of object;
  TCommErrorEvent = procedure(Sender: TAlohaPC1Comm; dwError: DWORD) of object;
  TErrorEvent = procedure(Sender: TAlohaPC1Comm; const Msg: string) of object;
  TTraceEvent = procedure(Sender: TAlohaPC1Comm; const Msg: string; Win32ErrCode: DWORD) of object;
  TAlohaPC1Address = 1..30;

  TAlohaPC1Comm = class(TComponent)
  private
    { Private 錾 }
    FHandle: THandle;                   // qr|QRQbnh
    FPortName: string;                  // |[g
    FAsyncHandling: Boolean;            // Cxgnh̔񓯊nhO
    FActive: Boolean;                   // 
    FSaveActive: Boolean;               // Active vpeBlꎞێp
    FThread: TThread;                   // ԊĎXbhIuWFNg
    FOnPhoneDetect: TPhoneDetectEvent;  // dbM
    FOnCommError: TCommErrorEvent;      // G[
    FOnError: TErrorEvent;              // Xbhł̃G[
    FOnTrace: TTraceEvent;              // g[XbZ[W
    FOnAsyncCommError: TCommErrorEvent; // i񓯊ĂяopjG[
    FOnAsyncError: TErrorEvent;         // i񓯊ĂяopjXbhł̃G[
    FOnAsyncTrace: TTraceEvent;         // i񓯊Ăяopjg[XbZ[W
    FROverlapped: TOverlapped;          // [hp̔񓯊h^n\̃f[^
    FWOverlapped: TOverlapped;          // Cgp̔񓯊h^n\̃f[^
    FCSHandshake: TCriticalSection;     // ʐMnhVFCNpNeBJZNV
    FhSyncWnd: HWND;                    // XbhԓpEBhEnh
    FReadWriteBusy: Boolean;            // ReadMemory܂WriteMemorystOi2010/6/21ǉj
    FCheck2ndPacket: Boolean;           // Mɍŏ̃pPbgɎ󂯎ꂽ2Ԗڂ̃pPbg邩ǂ҂ǂi2010/7/9ǉj
    procedure SetPortName(const Value: string);
    procedure SetActive(Value: Boolean);
    procedure DoCommError(dwError: DWORD);
    procedure DoPhoneDetect(const Packet: TPhoneNumberPacket);
    function DoCtsChanged_Thread(CtsOn: Boolean; var Packet: TPhoneNumberPacket): Boolean;
    procedure DoError(const Msg: string);
    procedure DoTrace(const Msg: string; Win32ErrCode: DWORD);
    procedure BeginHandshake;
    procedure EndHandshake;
    function GetInQueSize: Integer;
    function GetOutQueSize: Integer;
    procedure SetRts;
    procedure ClrRts;
    function IsCtsOn: Boolean;
    function Write(const Data; Count: DWORD): Boolean;
    procedure Read(var Data; Count: DWORD);
    procedure TRACE(const Msg: string; Win32ErrCode: DWORD=0);
    procedure TRACE_APICHK(Result: Boolean; const APIName: string);
    procedure CheckChanging;
    procedure CheckActive;
    procedure SyncWndProc(var Message: TMessage);
  protected
    { Protected 錾 }
    procedure Loaded; override;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Open;
    procedure Close;
    procedure ReadMemory(Addr: TAlohaPC1Address; var Packet: TPhoneNumberPacket);
    procedure WriteMemory(const Number: string);
  published
    { Published 錾 }
    property Active: Boolean read FActive write SetActive;
    property AsyncHandling: Boolean read FAsyncHandling write FAsyncHandling;
    property PortName: string read FPortName write SetPortName;
    property Check2ndPacket: Boolean read FCheck2ndPacket write FCheck2ndPacket default False;    // 2010/7/9ǉ
    property OnPhoneDetect: TPhoneDetectEvent read FOnPhoneDetect write FOnPhoneDetect;
    property OnCommError: TCommErrorEvent read FOnCommError write FOnCommError;
    property OnError: TErrorEvent read FOnError write FOnError;
    property OnTrace: TTraceEvent read FOnTrace write FOnTrace;
    (* 񓯊Ăяop *)
    property OnAsyncCommError: TCommErrorEvent read FOnAsyncCommError write FOnAsyncCommError;
    property OnAsyncError: TErrorEvent read FOnAsyncError write FOnAsyncError;
    property OnAsyncTrace: TTraceEvent read FOnAsyncTrace write FOnAsyncTrace;
  end;


//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   AnobPʐMG[ONX                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
  EAlohaPC1CommError = class(Exception)
  private
    FErrorCode: Integer;                // TAlohaPC1Comm ̃G[R[h
    FWin32ErrCode: DWORD;               // Win32 G[R[hiGetLastErrorj
  public
    constructor Create(const Msg: string; AErrorCode: Integer; AWin32ErrCode: DWORD=0);
    property ErrorCode: Integer read FErrorCode write FErrorCode;
    property Win32ErrCode: DWORD read FWin32ErrCode write FWin32ErrCode;
  end;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   EAlohaPC1CommError G[R[h\                                    //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
const
  // I[v֘AG[
  CAPC1ERR_CAN_NOT_OPEN          = $0101; // I[vłȂiCreateFilej
  CAPC1ERR_DONE_OPENED           = $0110; // I[vĂ邽ߗv͎󂯕tȂ
  CAPC1ERR_DO_NOT_OPEN           = $0120; // I[vĂȂ

  // WriteFile G[
  CAPC1ERR_WRITE_NOT_ENOUGH      = $0201; // ݕs
  CAPC1ERR_CAN_NOT_WRITE         = $0202; // ݂łȂ

  // ReadFile G[
  CAPC1ERR_READ_NOT_ENOUGH       = $0211; // ǂݍݕs
  CAPC1ERR_CAN_NOT_READ          = $0212; // ǂݍ݂łȂ

  // ǂݏo֘A
  CAPC1ERR_RM_WriteTimeout       = $0301; // MpPbg̑M^CAEg
  CAPC1ERR_RM_ReadError          = $0302; // M^CAEg܂͎Mf[^ُ

  // o֘A
  CAPC1ERR_WM_WriteTimeout       = $0401; // MpPbg̑M^CAEg
  CAPC1ERR_WM_ReadError          = $0402; // M^CAEg܂͎Mf[^ُ
  CAPC1ERR_WM_Not_Ack            = $0403; // ACK ȊOM

  // dbM֘A
  CAPC1ERR_DETECT_ReadError      = $0501; // M^CAEg܂͎Mf[^ُ

  // ̑
  CAPC1ERR_CTS_OFF               = $0901; // bsrIt


procedure EnumSerialCommPortNames(List: TStrings);
procedure ScanAlohaPC1Ports(List: TStrings; AllPortsScan: Boolean = True);
procedure Register;

implementation

//{$R AlohaPC1Comm.dcr} // R|[lgC[W
{$I AlohaPC1Comm.inc} // [JCY\[XXgO`

const
  CM_ON_PHONE_DETECT   = WM_USER + $100;
  CM_ON_COMMERROR      = WM_USER + $101;
  CM_ON_ERROR          = WM_USER + $102;
  CM_ON_TRACE          = WM_USER + $103;

//**************************************************************************//
//  Name      | Register                                                    //
//  Comment   | R|[lg̓o^                                        //
//**************************************************************************//
procedure Register;
begin
  RegisterComponents('hit CTI', [TAlohaPC1Comm]);
end;

//**************************************************************************//
//  Name      | EnumSerialCommPortNames                                     //
//  Comment   | ݎgpĂob}VŗpłVAʐM|[g//
//            | ̗                                                      //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  List            | O | 񋓐XgOXgIuWFNg                //
//--------------------------------------------------------------------------//
//  Note      | Xge̓NAĂȂB                              //
//**************************************************************************//
procedure EnumSerialCommPortNames(List: TStrings);
var
  KeyNames: TStringList;
  Reg: TRegistry;
  I: Integer;
begin
  Reg := TRegistry.Create;
  try
    Reg.RootKey := HKEY_LOCAL_MACHINE;
    // ǂݍݐpŊJ悤ɕύXi2010/6/3j
    //if Reg.OpenKey('\Hardware\DeviceMap\SerialComm', False) then begin
    if Reg.OpenKeyReadOnly('\Hardware\DeviceMap\SerialComm') then begin
      KeyNames := TStringList.Create;
      try
        Reg.GetValueNames(KeyNames);
        for I:=0 to KeyNames.Count-1 do
          List.Add( Reg.ReadString(KeyNames[I]) );
      finally
        KeyNames.Free;
      end;
    end;
  finally
    Reg.Free;
  end;
end;

//**************************************************************************//
//  Name      | ScanAlohaPC1Ports                                           //
//  Comment   | AnobPڑĂbnl|[g𒲂ׂ            //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  List            | O | ڑĂ|[gQ                          //
//                  |   | iڑĂ邪ŎgĂ|[g        //
//                  |   | ܂܂Ȃj                                        //
// AllPortsScan     | I | True  = ׂẴ|[gXL            //
//                  |   | False = _ŏI      //
//--------------------------------------------------------------------------//
//  Note      | Xge̓NAĂȂB                              //
//**************************************************************************//
procedure ScanAlohaPC1Ports(List: TStrings; AllPortsScan: Boolean = True);
var
  Aloha: TAlohaPC1Comm;

  // PortName  COM |[gƒʐM AlohaPC1 ǂׂ
  function TestCommPort(const PortName: string): Boolean;
  var
    Packet: TPhoneNumberPacket;
  begin
    Result := True;
    try
      Aloha.PortName := PortName;
      Aloha.Open;
      Aloha.ReadMemory(1, Packet);
      Aloha.Close;
    except
      Aloha.Close;
      Result := False;
    end;
  end;

var
  CommPorts: TStringList;
  I: Integer;
begin
  CommPorts := TStringList.Create;
  try
    // ̃}Vɂ邷ׂĂ̂bnl|[g擾
    EnumSerialCommPortNames(CommPorts);
    if CommPorts.Count = 0 then Exit;

    Aloha := TAlohaPC1Comm.Create(nil);
    try
      for I:=0 to CommPorts.Count-1 do
        if TestCommPort(CommPorts[I]) then
          List.Add(CommPorts[I]);
    finally
      Aloha.Free;
    end;
  finally
    CommPorts.Free;
  end;
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   AnobPʐMG[ONXF\bh̎                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//

//**************************************************************************//
//  Name      | EAlohaPC1CommError.Create                                   //
//  Comment   | RXgN^                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | G[bZ[W                                  //
//  AErrorCode      | I | G[R[h                                      //
//  AWin32ErrCode   | I | WIN32 G[R[hiGetLastError ̒lj           //
//**************************************************************************//
constructor EAlohaPC1CommError.Create(const Msg: string; AErrorCode: Integer; AWin32ErrCode: DWORD=0);
begin
  inherited Create(Msg); { Exception.Create }

  FErrorCode    := AErrorCode;
  FWin32ErrCode := AWin32ErrCode; // 0 = Win32 Ƃ͖֌W
end;

//**************************************************************************//
//  Name      | RaiseAPC1Error                                              //
//  Comment   | EAlohaPC1CommError O𔭐                         //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | G[bZ[W                                  //
//  AErrorCode      | I | G[R[h                                      //
//  AWin32ErrCode   | I | WIN32 G[R[hiGetLastError ̒lj           //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: OIuWFNg               //
//**************************************************************************//
procedure RaiseAPC1Error(const Msg: string; AErrorCode: Integer; AWin32ErrCode: DWORD=0);
begin
  raise EAlohaPC1CommError.Create(Msg, AErrorCode, AWin32ErrCode);
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   ʐMԊĎXbhNX                                       //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
type
  TEventWatchThread = class(TThread)
  private
    FAlohaPC1Comm: TAlohaPC1Comm;       // Ď TAlohaPC1Comm IuWFNg
    procedure DoEventChanged(dwEvent: DWORD);
  protected
    procedure Execute; override;
  public
    constructor Create(AlohaPC1Comm: TAlohaPC1Comm);
  end;

//**************************************************************************//
//  Name      | TEventWatchThread.Create                                    //
//  Comment   | RXgN^                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  AlohaPC1Comm    | I | ĎΏۂ̒ʐMR|[lg                      //
//**************************************************************************//
constructor TEventWatchThread.Create(AlohaPC1Comm: TAlohaPC1Comm);
begin
  inherited Create(True); { TThread.Create }

  // Ď TAlohaPC1Comm R|[lgIuWFNg̕ێ
  FAlohaPC1Comm := AlohaPC1Comm;

  // XbhĨIuWFNg̎p
  FreeOnTerminate := True;

  // Xbh̎sJn
  Resume;
end;

//**************************************************************************//
//  Name      | TEventWatchThread.Execute                                   //
//  Comment   | Ď                                                    //
//**************************************************************************//
procedure TEventWatchThread.Execute;
var
  dwEvent: DWORD;
  Result: BOOL;
  Win32ErrCode: DWORD;
begin
  while not Terminated do begin
    try
      // ʐMCxg̑ҋ@
      Result := WaitCommEvent(FAlohaPC1Comm.FHandle, dwEvent, nil);
      if Terminated then
        Break;


      // 2010/5/27ǉ
      // I[vɃP[u𔲂ꍇ́AWaitCommEvent邽߁A
      // CPUgp100%߂ɂȂ邽Sleep(1)ǉB
      Sleep(1);


      // ʐMCxg
      if Result then begin
        // N[YƂ dwEvent = 0 ɂȂ
        if dwEvent <> 0 then
          DoEventChanged(dwEvent)
        else
          Break;
      end
      else begin
        // AnPC1USBŐڑĂƂɁA
        // USB甲 WaitCommEvent߂l FalseɂȂ邽߁A
        // ł̏Ԃm点邽߂ DoTrace Ăяo悤ɂBi2010/6/2ǉj
        Win32ErrCode := GetLastError;
        FAlohaPC1Comm.DoTrace('WaitCommEvent', Win32ErrCode);
      end;
    except
      on E: Exception do begin
        try
          FAlohaPC1Comm.DoError(E.Message);
        except end;
      end;
    end;
  end;
end;

//**************************************************************************//
//  Name      | TEventWatchThread.DoEventChanged                            //
//  Comment   | Cxgω                                              //
//**************************************************************************//
procedure TEventWatchThread.DoEventChanged(dwEvent: DWORD);
var
  Stat: TComStat;
  ModemStat: DWORD;
  CtsOn: Boolean;
  CommError: DWORD;
  Packet: TPhoneNumberPacket;
begin
  // G[̏ꍇ
  if (dwEvent and EV_ERR) <> 0 then begin
    ClearCommError(FAlohaPC1Comm.FHandle, CommError, @Stat);
    FAlohaPC1Comm.DoCommError(CommError);
  end;

  // bsrMωꍇ
  if (dwEvent and EV_CTS) <> 0 then begin
    GetCommModemStatus(FAlohaPC1Comm.FHandle, ModemStat);
    CtsOn := (ModemStat and MS_CTS_ON) <> 0;

    // M`FbN
    if FAlohaPC1Comm.DoCtsChanged_Thread(CtsOn, Packet) then
      FAlohaPC1Comm.DoPhoneDetect(Packet);
  end;
end;



//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   AnobPʐMR|[lgNXF\bh̎                 //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//

//**************************************************************************//
//  Name      | TAlohaPC1Comm.Create                                        //
//  Comment   | RXgN^                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  AOwner          | I | I[i[                                          //
//**************************************************************************//
constructor TAlohaPC1Comm.Create(AOwner: TComponent);
begin
  inherited Create(AOwner); { TComponent.Create }

  // f[^̏ݒ
  FHandle        := INVALID_HANDLE_VALUE;   // nh̖
  FActive        := False;                  // N[Y
  FPortName      := 'COM1';                 // COM1
  FAsyncHandling := False;                  // Cxgnh̃CXbhƂ̓Ăяo

  FCheck2ndPacket := False;                 // Mɍŏ̃pPbgɎ󂯎ꂽ2Ԗڂ̃pPbg邩ǂ҂ǂi2010/7/9ǉj

  // Cxgnh̖
  FOnPhoneDetect    := nil;
  FOnCommError      := nil;
  FOnError          := nil;
  FOnTrace          := nil;
  FOnAsyncCommError := nil;
  FOnAsyncError     := nil;
  FOnAsyncTrace     := nil;

  // ʐMnhVFCNpNeBJZNVIuWFNg̐
  FCSHandshake := TCriticalSection.Create;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.Destroy                                       //
//  Comment   | fXgN^                                                //
//**************************************************************************//
destructor TAlohaPC1Comm.Destroy;
begin
  // N[Y
  Active := False;

  // ʐMnhVFCNpNeBJZNVIuWFNg̔p
  FCSHandshake.Free;

  inherited; { TComponent.Destroy }
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.Loaded                                        //
//  Comment   | vpeBl̃Xg[̃[h                //
//**************************************************************************//
procedure TAlohaPC1Comm.Loaded;
begin
  inherited; { TComponent.Loaded }

  // FSaveActive  True ȂI[v
  SetActive(FSaveActive);
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.SetActive                                     //
//  Comment   | ActivevpeB̐ݒ                                      //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Value           | I | True=I[v  False=N[Y             //
//**************************************************************************//
procedure TAlohaPC1Comm.SetActive(Value: Boolean);
begin
  // Xg[烍[h̏ꍇ͓tB[hɒlێĂɂ
  if csLoading in ComponentState then begin
    FSaveActive := Value;
    Exit;
  end;

  if FActive <> Value then begin

    // ݌v
    if csDesigning in ComponentState then
      FActive := Value

    // s
    else begin
      if Value then
        Open
      else
        Close;
    end;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.CheckChanging                                 //
//  Comment   | I[v̏ꍇ͗ON                          //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: I[v͕ύXłȂ                //
//**************************************************************************//
procedure TAlohaPC1Comm.CheckChanging;
begin
  // ŝ݃`FbN
  if not (csDesigning in ComponentState) then
    if Active then
      RaiseAPC1Error(SAPC1ERR_DONE_OPENED, CAPC1ERR_DONE_OPENED);
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.CheckActive                                   //
//  Comment   | ANeBuł邩̃`FbN                                //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: I[vĂȂ                      //
//**************************************************************************//
procedure TAlohaPC1Comm.CheckActive;
begin
  // ŝ݃`FbN
  if not (csDesigning in ComponentState) then
    if not Active then
      RaiseAPC1Error(SAPC1ERR_DO_NOT_OPEN, CAPC1ERR_DO_NOT_OPEN);
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.SetPortName                                   //
//  Comment   | ʐM|[g̐ݒ                                          //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Value           | I | |[gi'COM1'Ȃǁj                            //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: I[v͕ύXłȂ                //
//**************************************************************************//
procedure TAlohaPC1Comm.SetPortName(const Value: string);
begin
  if FPortName<>Value then begin

    // I[v̏ꍇ͗ON
    CheckChanging;

    FPortName := Value;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.TRACE                                         //
//  Comment   | g[XbZ[W̏o                                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | bZ[W                                        //
//  Win32ErrCode    | I | WIN32API sG[eiGetLastErrorj           //
//                  |   | iȗj                                      //
//--------------------------------------------------------------------------//
//  Result    | ĎXbhĂяo邱Ƃ_ɒӁB            //
//**************************************************************************//
procedure TAlohaPC1Comm.TRACE(const Msg: string; Win32ErrCode: DWORD=0);
begin
  // ̃R|[lgtH[ȂǓ\tāAI[v܂
  // I肷ƁAfXgN^Ăяoꂽ Close \bh
  // TRACE s邽߁A OnTrace nhŃI[i[tH[
  // łɔjꂽ\[XɃANZXĂ܂ꍇ蓾邽߁A
  // 邽߂ɂ̏ꂽBi2002/10/9j
  if csDestroying in ComponentState then
    Exit;

  DoTrace(Msg, Win32ErrCode);
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.TRACE_APICHK                                  //
//  Comment   | WIN32API sG[`FbN                                 //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Result          | I | ֐Ăяo                                  //
//  APIName         | I | `oh֐                                      //
//**************************************************************************//
procedure TAlohaPC1Comm.TRACE_APICHK(Result: Boolean; const APIName: string);
begin
  if not Result then
    TRACE(APIName, GetLastError);
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.BeginHandshake                                //
//  Comment   | rIȒʐMnhVFCN̊Jn                            //
//**************************************************************************//
procedure TAlohaPC1Comm.BeginHandshake;
begin
  FCSHandshake.Enter;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.EndHandshake                                  //
//  Comment   | rIȒʐMnhVFCN̏I                            //
//**************************************************************************//
procedure TAlohaPC1Comm.EndHandshake;
begin
  FCSHandshake.Leave;
end;

//**************************************************************************//
//  Name      | MakeDCB                                                     //
//  Comment   | DCB \̃f[^̐ݒ                                      //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  xDCB            | O | ݒ肵f[^̊i[                            //
//**************************************************************************//
procedure MakeDCB(var xDCB: TDCB);
var
  DCBObj: TDCBObject;
begin
  DCBObj := TDCBObject.Create;
  try
    // cbȁl̐ݒ
    DCBObj.DCBlength         := SizeOf(TDCB);        // sizeof(DCB) = 28
    DCBObj.BaudRate          := 9600;                // ʐMx=XUOO
    DCBObj.fBinary           := True;                // oCi[h
    DCBObj.fParity           := True;                // peB`FbN
    DCBObj.fOutxCtsFlow      := True;                // bsro̓t[䂷
    DCBObj.fOutxDsrFlow      := False;               // crqo̓t[䂵Ȃ
    DCBObj.fDtrControl       := DTR_CONTROL_ENABLE;  // icsqt[j
    DCBObj.fDsrSensitivity   := False;               // icrqxj
    DCBObj.fTXContinueOnXoff := False;               // wneeMpȂ
    DCBObj.fOutX             := False;               // wnm^wneeo̓t[䂵Ȃ
    DCBObj.fInX              := False;               // wnm^wnee̓t[䂵Ȃ
    DCBObj.fErrorChar        := False;               // G[ɂu𖳌
    DCBObj.fNull             := False;               // kXgbsO𖳌
    DCBObj.fRtsControl       := RTS_CONTROL_ENABLE;  // iqsrt[j
    DCBObj.fAbortOnError     := True;                // G[ɓǂݎ܂͏݂𒆎~
//  DCBObj.fDummy            := ?                    // i\ς݁j
    DCBObj.wReserved         := 0;                   // io[Wł͎gȂj
    DCBObj.XonLim            := 0;                   // MɂwnmXbVh
    DCBObj.XoffLim           := 0;                   // MɂwneeXbVh
    DCBObj.ByteSize          := 7;                   // f[^rbgVrbg
    DCBObj.Parity            := EVENPARITY;          // peB[peB
    DCBObj.StopBits          := ONESTOPBIT;          // XgbvrbgPrbg
    DCBObj.XonChar           := #$11;                // iMюMɑ΂wnmj
    DCBObj.XoffChar          := #$13;                // iMюMɑ΂wneej
    DCBObj.ErrorChar         := #$00;                // iG[uj
    DCBObj.EofChar           := #$00;                // ȉ͕Ij
    DCBObj.EvtChar           := #$00;                // i󂯎Cxgj
//  DCBObj.wReserved1        := ?                    //
    Move(DCBObj.FDCB, xDCB, SizeOf(TDCB));
  finally
    DCBObj.Free;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.Open                                          //
//  Comment   | ʐM̃I[vM                                //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: I[vłȂAp[^G[Ȃ  //
//**************************************************************************//
procedure TAlohaPC1Comm.Open;
var
  xDCB: TDCB;
  EventMask: DWORD;
  ctmo: TCommTimeouts;
begin
  // ɃI[vĂ牽Ȃ
  if Active then Exit;

  TRACE('***I[v***');

  // ʐMfoCX̃I[v
  FHandle := CreateFile(
                //PChar(FPortName),               // |[g
                PChar('\\.\' + FPortName),      // |[g : COM10ȍ~Ήi2010/4/22Cj
                GENERIC_READ or GENERIC_WRITE,  // ANZX[h
        		0,                              // L rIgp
                nil,                            // ZLeBȂ
                OPEN_EXISTING,                  // 쐬@  
                                        	    // t@C  ʏAI[o[bvo }
                                                // FILE_FLAG_OVERLAPPED tȂƊ֐߂ĂȂ
                FILE_ATTRIBUTE_NORMAL or FILE_FLAG_OVERLAPPED,
                0);                             // Rs[鑮tt@C̃nh
  if FHandle=INVALID_HANDLE_VALUE then
    RaiseAPC1Error( Format(SAPC1ERR_CAN_NOT_OPEN, [FPortName]),
                    CAPC1ERR_CAN_NOT_OPEN,
                    GetLastError );

  try
    // cba\̃f[^̐ݒ
    MakeDCB(xDCB);

    // ʐMfoCX̐f[^̐ݒ
    TRACE_APICHK(
       SetCommState(FHandle, xDCB),
      'SetCommState');

    // ́^o̓obt@TCY̐ݒ
    TRACE_APICHK(
       SetupComm(FHandle, 128, 128), // InQueue=128, OutQueue=128
      'SetupComm');

    // ́^o̓obt@̓eNA
    TRACE_APICHK(
       PurgeComm(FHandle, PURGE_TXABORT or PURGE_TXCLEAR or PURGE_RXABORT or PURGE_RXCLEAR),
      'PurgeComm');

    // ^CAEg̐ݒi^CAEg͎gpȂ悤ɂĂj
    ctmo.ReadIntervalTimeout         := $FFFFFFFF;
    ctmo.ReadTotalTimeoutMultiplier  := 0;
    ctmo.ReadTotalTimeoutConstant    := 0;
    ctmo.WriteTotalTimeoutMultiplier := 0;
    ctmo.WriteTotalTimeoutConstant   := 0;
    TRACE_APICHK(
       SetCommTimeouts(FHandle, ctmo),
      'SetCommTimeouts');

    // ĎCxg̐ݒ
    EventMask := EV_CTS or EV_ERR;
    TRACE_APICHK(
       SetCommMask(FHandle, EventMask),
      'SetCommMask');

    // [hp񓯊h^n\̃f[^̐ݒ
    FROverlapped.Offset     := 0;
    FROverlapped.OffsetHigh := 0;
    FROverlapped.hEvent     := CreateEvent(nil, True, False, nil);
    Assert(FROverlapped.hEvent<>0);

    // Cgp񓯊h^n\̃f[^̐ݒ
    FWOverlapped.Offset     := 0;
    FWOverlapped.OffsetHigh := 0;
    FWOverlapped.hEvent     := CreateEvent(nil, True, False, nil);
    Assert(FWOverlapped.hEvent<>0);

    // 񓯊nhȌꍇ́AXbhԓpEBhE쐬
    if not FAsyncHandling then
      FhSyncWnd := AllocateHWnd(SyncWndProc)
    else
      FhSyncWnd := 0;


    // qsrnmɂĂi2010/6/21ǉj
    //  ł͂ȂAꉞǉB
    SetRts;

    // ReadMemory܂WriteMemorystONAi2010/6/21ǉj
    FReadWriteBusy := False;


    // ʐMԊĎXbhIuWFNg̐
    FThread := TEventWatchThread.Create(Self);
    Assert(Assigned(FThread));
  except
    // ʐMfoCX̃N[YAnh̖
    CloseHandle(FHandle);
    FHandle := INVALID_HANDLE_VALUE;

    // Ođ
    raise;
  end;

  FActive := True;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.Close                                         //
//  Comment   | ʐM̃N[Y                                          //
//**************************************************************************//
procedure TAlohaPC1Comm.Close;
begin
  // I[vĂȂꍇ͉Ȃ
  if not Active then Exit;

  TRACE('***N[Y***');

  // Xbh̏I
  // dvjSetCommMask֐ĂяoĂ̂̓Xbh[`
  //       WaitCommEvent֐̌ĂяoI邽߂łB
  FThread.Terminate;
  TRACE_APICHK(
     SetCommMask(FHandle, 0),
    'SetCommMask');
  Sleep(200);

  // ́^o̓obt@̓eNA
  TRACE_APICHK(
     PurgeComm(FHandle, PURGE_TXABORT or PURGE_TXCLEAR or PURGE_RXABORT or PURGE_RXCLEAR),
    'PurgeComm');

  // ʐMfoCX̃N[YAnh̖
  TRACE_APICHK(
     CloseHandle(FHandle),
    'CloseHandle');
  FHandle := INVALID_HANDLE_VALUE;

  // XbhԓpEBhE̔j
  if FhSyncWnd <> 0 then begin
    DeallocateHWnd(FhSyncWnd);
    FhSyncWnd := 0;
  end;

  FActive := False;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.GetInQueSize                                  //
//  Comment   | Mobt@ɓĂf[^TCY𒲂ׂ                //
//--------------------------------------------------------------------------//
//  Result    | Mobt@ɓĂf[^̃oCg                    //
//**************************************************************************//
function TAlohaPC1Comm.GetInQueSize: Integer;
var
  dwError: DWORD;
  ComStat: TComStat;
begin
  TRACE_APICHK(
     ClearCommError(FHandle, dwError, @ComStat),
    'ClearCommError');

  Result := ComStat.cbInQue;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.GetOutQueSize                                 //
//  Comment   | Mobt@ɓĂf[^TCY𒲂ׂ                //
//--------------------------------------------------------------------------//
//  Result    | Mobt@ɓĂf[^̃oCg                    //
//**************************************************************************//
function TAlohaPC1Comm.GetOutQueSize: Integer;
var
  dwError: DWORD;
  ComStat: TComStat;
begin
  TRACE_APICHK(
     ClearCommError(FHandle, dwError, @ComStat),
    'ClearCommError');

  Result := ComStat.cbOutQue;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.SetRts                                        //
//  Comment   | qsrMnmɂ                                      //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: API sG[                          //
//**************************************************************************//
procedure TAlohaPC1Comm.SetRts;
begin
  TRACE_APICHK(
     EscapeCommFunction(FHandle, Windows.SETRTS),
    'EscapeCommFunction - SETRTS');
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.ClrRts                                        //
//  Comment   | qsrMneeɂ                                    //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: API sG[                          //
//**************************************************************************//
procedure TAlohaPC1Comm.ClrRts;
begin
  TRACE_APICHK(
     EscapeCommFunction(FHandle, Windows.CLRRTS),
    'EscapeCommFunction - CLRRTS');
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.IsCtsOn                                       //
//  Comment   | bsrMnmǂ                                    //
//--------------------------------------------------------------------------//
//  Result    | True = bsrI  False = bsrIt               //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: API sG[                          //
//**************************************************************************//
function TAlohaPC1Comm.IsCtsOn: Boolean;
var
  ModemStat: DWORD;
begin
  TRACE_APICHK(
     GetCommModemStatus(FHandle, ModemStat),
    'GetCommModemStatus');
  Result := (ModemStat and MS_CTS_ON) <> 0;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.Write                                         //
//  Comment   | f[^                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Data            | I | ݃f[^                                    //
//  Count           | I | ݃f[^TCY                              //
//--------------------------------------------------------------------------//
//  Result    | True = ݂nj  False = 񓯊ݒ           //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: API sG[                          //
//**************************************************************************//
function TAlohaPC1Comm.Write(const Data; Count: DWORD): Boolean;
var
  WroteSize: DWORD;
  Win32ErrCode: DWORD;
begin
  // ݎ
  if WriteFile(FHandle, Data, Count, WroteSize, @FWOverlapped) then begin
    // ߂TCYvTCY菬ꍇ͗ON
    if Count <> WroteSize then
      RaiseAPC1Error(
        Format(SAPC1ERR_WRITE_NOT_ENOUGH, [Count, WroteSize]),
        CAPC1ERR_WRITE_NOT_ENOUGH);

     // ݊
     Result := True;
  end

  // ݎs
  else begin
    Win32ErrCode := GetLastError;
    if Win32ErrCode<>ERROR_IO_PENDING then
      RaiseAPC1Error(
        SAPC1ERR_CAN_NOT_WRITE,
        CAPC1ERR_CAN_NOT_WRITE,
        Win32ErrCode);

    // 񓯊ݒ
    Result := False;
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.Read                                          //
//  Comment   | f[^ǂݍ                                              //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Data            | O | ǂݍ݃f[^i[                              //
//  Count           | I | ǂݍ݃f[^TCY                              //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: API sG[                          //
//**************************************************************************//
//procedure TAlohaPC1Comm.Read(var Data; Count: DWORD);
//var
//  ReadSize: DWORD;
//begin
//  // ǂݍݎ
//  if ReadFile(FHandle, Data, Count, ReadSize, @FROverlapped) then begin
//    // ǂݍ߂TCYvTCY菬ꍇ͗ON
//    if Count <> ReadSize then
//      RaiseAPC1Error(
//        Format(SAPC1ERR_READ_NOT_ENOUGH, [Count, ReadSize]),
//        CAPC1ERR_READ_NOT_ENOUGH);
//  end
//
//  // ǂݍݎs
//  else
//    RaiseAPC1Error(
//        SAPC1ERR_CAN_NOT_READ,
//        CAPC1ERR_CAN_NOT_READ,
//        GetLastError);
//end;
// 2013/4/19 \bhu
procedure TAlohaPC1Comm.Read(var Data; Count: DWORD);
var
  ReadSize: DWORD;
  Win32ErrCode: DWORD;
begin
  // ǂݍݎ
  if ReadFile(FHandle, Data, Count, ReadSize, @FROverlapped) then begin
    // ǂݍ߂TCYvTCY菬ꍇ͗ON
    if Count <> ReadSize then
      RaiseAPC1Error(
        Format(SAPC1ERR_READ_NOT_ENOUGH, [Count, ReadSize]),
        CAPC1ERR_READ_NOT_ENOUGH);
  end

  // ǂݍݎs
  else begin
    // dI/OsĂꍇ
    Win32ErrCode := GetLastError;
    if Win32ErrCode = ERROR_IO_PENDING then begin
      TRACE('dI/Os(R)');
      // ǂݏI܂ő҂
      if GetOverlappedResult(FHandle, FROverlapped, ReadSize, True) then begin
        // ǂݍ߂TCYvTCY菬ꍇ͗ON
        if Count <> ReadSize then
          RaiseAPC1Error(
            Format(SAPC1ERR_READ_NOT_ENOUGH, [Count, ReadSize]),
            CAPC1ERR_READ_NOT_ENOUGH)
      end
      else
        RaiseAPC1Error(
            SAPC1ERR_CAN_NOT_READ,
            CAPC1ERR_CAN_NOT_READ,
            GetLastError);
    end

    // ERROR_IO_PENDING ȊÕG[̏ꍇ
    else
      RaiseAPC1Error(
          SAPC1ERR_CAN_NOT_READ,
          CAPC1ERR_CAN_NOT_READ,
          Win32ErrCode);
  end;

  // CxgNA
  ResetEvent(FROverlapped.hEvent);
end;



//**************************************************************************//
//  Name      | TAlohaPC1Comm.ReadMemory                                    //
//  Comment   | ǂݏo                                            //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Addr            | I | ԒniP`RPj                            //
//  Packet          | O | ǂݍ񂾓dbԍpPbg̊i[                //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: ǂݏoG[                    //
//**************************************************************************//
procedure TAlohaPC1Comm.ReadMemory(Addr: TAlohaPC1Address; var Packet: TPhoneNumberPacket);
type
  TReadMemPacket = packed record
    case Integer of
      0: (
        Data: array[0..4] of Char);
      1: (
        STX: Char;
        M: Char;
        Addr: array[0..1] of Char;
        ETX: Char);
  end;
const
  READMEMPACKET_SIZE = SizeOf(TReadMemPacket);

  // pPbgM҂^CAEg  Windows.WAIT_TIMEOUT($00000102)QƂĂ܂Ă߂Œ`i2010/6/21萔錾ǉj
  WAIT_TIMEOUT = 1000;
var
  OutPacket: TReadMemPacket;
  EndTime: DWORD;
  Msg: string;      // 2010/6/21ǉ
  QueSize: Integer; // 2010/6/21ǉ
begin
  // I[vĂȂꍇ͗ON
  CheckActive;

  TRACE('***AnPC1ǂݏoJn***');

  // MpPbg̍쐬
  OutPacket.STX     := #2;
  OutPacket.M       := 'M';
  OutPacket.Addr[0] := Char(Byte('0') + ((Addr div 10) mod 10));
  OutPacket.Addr[1] := Char(Byte('0') + (Addr mod 10));
  OutPacket.ETX     := #3;

  // rIʐMJn
  BeginHandshake;
  FReadWriteBusy := True;   // ReadMemorystOZbgi2010/6/21j
  try
    // ÔߑMobt@NA
    TRACE_APICHK(
       PurgeComm(FHandle, PURGE_TXABORT or PURGE_TXCLEAR or PURGE_RXABORT or PURGE_RXCLEAR),
      'PurgeComm');

    // bsrIt̏ꍇ͑MłȂ
    if not IsCtsOn then begin
      TRACE('CTSOFF̂߃ǂݏoł܂B');    // 2010/6/21ǉ
      RaiseAPC1Error(SAPC1ERR_CTS_OFF,
                     CAPC1ERR_CTS_OFF);
    end;

    // qsrɗGbW
    TRACE('RTSOFFɂ܂B');    // 2010/6/22ǉ
    SetRts; Sleep(10); ClrRts;

    // TOȏ҂i2002/10/11 100ms  50ms ɕύXj
    Sleep(50);

    // f[^𑗐M
    TRACE('ǂݏoR}hM');
    if not Write(OutPacket, READMEMPACKET_SIZE) then begin
      EndTime := GetTickCount + 1000; // ݃^CAEgP
      while (GetOutQueSize > 0) and (GetTickCount < EndTime) do
        Sleep(10);
    end;

    // qsrnmɖ߂Ă
    TRACE('RTSONɂ܂B');    // 2010/6/22ǉ
    SetRts;

    // M^CAEgǂ
    //if GetOutQueSize > 0 then begin
    QueSize := GetOutQueSize;
    if QueSize > 0 then begin
      Msg := Format('M^CAEgiOutQueSize=%dj', [QueSize]);
      TRACE(Msg);   // 2010/6/21ǉ

      RaiseAPC1Error(SAPC1ERR_WriteTimeout,
                     CAPC1ERR_RM_WriteTimeout);
    end;

    // TO҂i2002/10/11 100ms  50ms ɕύXj
    Sleep(50);

    // RPoCgM邩^CAEgɂȂ܂ő҂
    EndTime := GetTickCount + WAIT_TIMEOUT;
    while (GetInQueSize < PHONE_NUMBER_PACKET_SIZE) and (GetTickCount < EndTime) do
      Sleep(10);

    // Młꍇ
    //if GetInQueSize = PHONE_NUMBER_PACKET_SIZE then begin
    QueSize := GetInQueSize;
    if QueSize = PHONE_NUMBER_PACKET_SIZE then begin
      TRACE('ML[dbԍpPbg̓ǂݍ');    // 2010/6/22ǉ

      // Mobt@ǂݏo
      Read(Packet, PHONE_NUMBER_PACKET_SIZE);
    end

    // M^CAEg܂͎Mf[^ُ
    else begin
      Msg := Format('M^CAEg܂͎Mf[^ُ픭iInQueSize=%dj', [QueSize]);
      TRACE(Msg);   // 2010/6/21ǉ

      RaiseAPC1Error(SAPC1ERR_ReadError,
                     CAPC1ERR_RM_ReadError);
    end;

  finally
    FReadWriteBusy := False;    // ReadMemorystONAi2010/6/21j

    // rIʐMI
    EndHandshake;

    TRACE('***AnPC1ǂݏoI***');
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.WriteMemory                                   //
//  Comment   | dbԍɐݒ肷                                  //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Number          | I | ݒ肷dbԍ                                  //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: ݒG[                        //
//**************************************************************************//
procedure TAlohaPC1Comm.WriteMemory(const Number: string);
type
  TWriteMemPacket = packed record
    case Integer of
      0: (
        Data: array[0..22] of Char);
      1: (
        STX: Char;                    // STX = #02
        D: Char;                      // 'D'
        Number: array[0..19] of Char; // dbԍ
        ETX: Char);                   // ETX = #03
  end;
const
  WRITEMEMPACKET_SIZE = SizeOf(TWriteMemPacket);

  // ACKM҂^CAEg  Windows.WAIT_TIMEOUT($00000102)QƂĂ܂Ă߂Œ`i2010/6/21萔錾ǉj
  WAIT_TIMEOUT = 1000;
var
  OutPacket: TWriteMemPacket;
  Len: Integer;
  EndTime: DWORD;
  AckNak: Char;
  Msg: string;      // 2010/6/21ǉ
  QueSize: Integer; // 2010/6/21ǉ
begin
  // I[vĂȂꍇ͗ON
  CheckActive;

  TRACE('***AnPC1oJn***');

  // MpPbg̍쐬
  OutPacket.STX    := #2;
  OutPacket.D      := 'D';
  OutPacket.ETX    := #3;
  FillChar(OutPacket.Number,20, ' ');
  Len := Length(Number);
  if Len > 20 then Len := 20;
  Move(Number[1], OutPacket.Number, Len);

  // rIʐMJn
  BeginHandshake;
  FReadWriteBusy := True;   // WriteMemorystOZbgi2010/6/21j
  try
    // ÔߑMobt@NA
    TRACE_APICHK(
       PurgeComm(FHandle, PURGE_TXABORT or PURGE_TXCLEAR or PURGE_RXABORT or PURGE_RXCLEAR),
      'PurgeComm');

    // bsrIt̏ꍇ͑MłȂ
    if not IsCtsOn then begin
      TRACE('CTSOFF̂߃oł܂B');    // 2010/6/21ǉ
      RaiseAPC1Error(SAPC1ERR_CTS_OFF,
                     CAPC1ERR_CTS_OFF);
    end;

    // qsrɗGbW
    TRACE('RTSOFFɂ܂B');    // 2010/6/22ǉ
    SetRts; sleep(10); ClrRts;

    // TOȏ҂i2002/10/11 100ms  50ms ɕύXj
    Sleep(50);

    // f[^𑗐M
    TRACE('oR}hM');
    if not Write(OutPacket, WRITEMEMPACKET_SIZE) then begin
      EndTime := GetTickCount + 1000; // ݃^CAEgP
      while (GetOutQueSize > 0) and (GetTickCount < EndTime) do
        Sleep(10);
    end;

    // qsrnmɖ߂Ă
    TRACE('RTSONɂ܂B');    // 2010/6/22ǉ
    SetRts;

    // M^CAEgǂ
    //if GetOutQueSize > 0 then begin
    QueSize := GetOutQueSize;
    if QueSize > 0 then begin
      Msg := Format('M^CAEgiOutQueSize=%dj', [QueSize]);
      TRACE(Msg);   // 2010/6/21ǉ

      RaiseAPC1Error(SAPC1ERR_WriteTimeout,
                     CAPC1ERR_WM_WriteTimeout);
    end;

    // TO҂i2002/10/11 100ms  50ms ɕύXj
    Sleep(50);

    // PoCgi`bjjM邩^CAEgɂȂ܂ő҂
    EndTime := GetTickCount + WAIT_TIMEOUT;
    while (GetInQueSize < 1) and (GetTickCount < EndTime) do
      Sleep(10);

    // Młꍇ
    //if GetInQueSize = 1 then begin
    QueSize := GetInQueSize;
    if QueSize = 1 then begin

      TRACE('ML[ACK/NAK̓ǂݍ');    // 2010/6/22ǉ

      // Mobt@ǂݏo
      Read(AckNak, 1);

      // ACK ǂ`FbN
      if AckNak <> #6 then
        RaiseAPC1Error(SAPC1ERR_WM_Not_Ack,
                       CAPC1ERR_WM_Not_Ack);
    end

    // M^CAEg܂͎Mf[^ُ
    else begin
      Msg := Format('M^CAEg܂͎Mf[^ُ픭iInQueSize=%dj', [QueSize]);
      TRACE(Msg);   // 2010/6/21ǉ

      RaiseAPC1Error(SAPC1ERR_ReadError,
                     CAPC1ERR_WM_ReadError);
    end;

  finally
    FReadWriteBusy := False;    // WriteMemorystONAi2010/6/21j

    // rIʐMI
    EndHandshake;

    TRACE('***AnPC1oI***');
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.DoCtsChanged_Thread                           //
//  Comment   | bsrMωƂ                                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  CtsOn           | I | True = bsrI  False = bsrIt             //
//  Packet          | O | MdbԍpPbgiResult=TruêݗLj //
//--------------------------------------------------------------------------//
//  Result    | True = db𒅐M  False = MĂȂ               //
//--------------------------------------------------------------------------//
//  Exception | EAlohaPC1CommError: ʐMG[                              //
//--------------------------------------------------------------------------//
//  Note      | ̃\bh̓CXbhƔ񓯊ŌĂ΂邽ߒӂ- //
//            | ƁB                                                      //
//**************************************************************************//
function TAlohaPC1Comm.DoCtsChanged_Thread(CtsOn: Boolean; var Packet: TPhoneNumberPacket): Boolean;
const
  WAIT_TIMEOUT = 1000; // M҂^CAEg
var
  EndTime: DWORD;
  Ack: Char;
  Incoming: Boolean;    // MtOi2010/6/21ǉj
  QueSize: Integer;     // 2010/6/21ǉ
  Msg: string;          // 2010/6/21ǉ
  CtsOnTime: DWORD;     // CTSONɂȂԁi2010/7/8ǉj
begin
  Result := False;

  if CtsOn then
    TRACE('***bsrI***')
  else
    TRACE('***bsrIt***');


  // ReadMemory܂WriteMemory\bhs̏ꍇ͉Ȃi2010/6/21ǉj
  //  NeBJZNVŔr䂵Ă邪Ô߃tO`FbNǉB
  if FReadWriteBusy then begin
    TRACE('ǂݏoA܂̓os');
    Exit;
  end;


  // bsrnm̂ƂɎMf[^ΒMf[^ubNǂݏo
  if CtsOn then begin

    // CTSONɂȂԂoĂ
    CtsOnTime := GetTickCount;

    // MtONA
    Incoming := False;

    // rIʐMJn
    BeginHandshake;
    try
      //********************************************************************//
      // dbM                                                         //
      // CTS=ON̎_łłɃpPbgMĂ̂ƂB             //
      //********************************************************************//
      if GetInQueSize > 0 then begin

        (* ȉ̃R[hCi2010/6/21j *)

        // MtOZbg
        Incoming := True;

        TRACE('***dbMJn***');

        // ̎_ŃAnMĂ邽߁A҂Ȃi2010/7/8j
        //// RPoCgM邩^CAEgɂȂ܂ő҂
        //EndTime := GetTickCount + WAIT_TIMEOUT;
        //while (GetInQueSize < PHONE_NUMBER_PACKET_SIZE) and (GetTickCount < EndTime) do
        //  Sleep(10);


        //******************************************************************//
        // Młꍇ                                             //
        //******************************************************************//
        //if GetInQueSize = PHONE_NUMBER_PACKET_SIZE then begin
        QueSize := GetInQueSize;
        if QueSize = PHONE_NUMBER_PACKET_SIZE then begin

          TRACE('ML[dbԍpPbg̓ǂݍ');    // 2010/6/22ǉ

          // Mobt@ǂݏo
          Read(Packet, PHONE_NUMBER_PACKET_SIZE);

          // qsrɗGbW
          TRACE('RTSOFFɂ܂B');    // 2010/6/22ǉ
          SetRts; Sleep(10); ClrRts;

          // 100msȏ҂
          Sleep(100);


          // ACK Ԃ
          Ack := #6;

          // f[^𑗐M
          TRACE('ACK𑗐M܂'); // 2010/6/21ǉ
          if not Write(Ack, 1) then begin
            EndTime := GetTickCount + 300; // ݃^CAEg300ms
            while (GetOutQueSize > 0) and (GetTickCount < EndTime) do
              Sleep(10);
          end;

          // qsrnmɖ߂Ă
          TRACE('RTSONɂ܂B');    // 2010/6/22ǉ
          SetRts;

          // M^CAEgǂ
          QueSize := GetOutQueSize;
          if QueSize > 0 then begin
            Msg := Format('M^CAEgiOutQueSize=%dj', [QueSize]);
            TRACE(Msg);   // 2010/6/21ǉ

            RaiseAPC1Error(SAPC1ERR_WriteTimeout,
                           CAPC1ERR_RM_WriteTimeout);
          end;


          // đMpPbg܂ő҂ꍇi2010/7/9ǉj
          if FCheck2ndPacket then begin
            TRACE('đMpPbg邩`FbN܂B');
            // AnUSBhCoA܂USBVAϊP[ũhCo
            // sŋz邽߂̏ǉi2010/7/8j
            // AnACK`Ȃƍŏ̒MpPbgM1b
            // pPbgđMĂ邽߁AdM邽߂
            // 1.2bi܂̓pPbgMjɎMobt@NA鏈B
            // ҂ԂƂƂꂾMCxgx邽ߋɗ͒ZԂɂ邱ƁB
            // j
            // AñpPbgđMCTS=ONɂȂ邽߁AƂCTS ON Cxg邪A
            // ̎_ł͎Mobt@̂͂ł邩dMƂ͂Ȃ炢B
            EndTime := CtsOnTime + 1200;
            while (GetInQueSize < PHONE_NUMBER_PACKET_SIZE) and (GetTickCount < EndTime) do
              Sleep(10);
            QueSize := GetInQueSize;
            if QueSize <> 0 then begin
              Msg := Format('MpPbg̓dMiInQueSize=%dj', [QueSize]);
              TRACE(Msg);
              TRACE_APICHK(
                 PurgeComm(FHandle, PURGE_TXABORT or PURGE_TXCLEAR or PURGE_RXABORT or PURGE_RXCLEAR),
                'PurgeComm');
            end;
          end;


          // dbMnj
          Result := True;
        end


        //******************************************************************//
        // M^CAEg܂͎Mf[^ُ                             //
        //******************************************************************//
        else begin
          Msg := Format('M^CAEg܂͎Mf[^ُ픭iInQueSize=%dj', [QueSize]);
          TRACE(Msg);   // 2010/6/21ǉ

          // Mobt@NAĂi2010/7/8ǉj
          Sleep(100);   // ҂
          TRACE_APICHK(
             PurgeComm(FHandle, PURGE_TXABORT or PURGE_TXCLEAR or PURGE_RXABORT or PURGE_RXCLEAR),
            'PurgeComm');

          // AnUSBhCoA܂USBVAϊP[ũhCo
          // sŋz邽߂̏ǉi2010/7/8j
          // ł̓AnACK𑗐MĂȂ߁A1bɃAn瓯pPbgđM邽߁A
          // đMꂽpPbgG[ɂMs悤ɂB
          // 1.2bi܂̓pPbgMj܂ő҂ĎMobt@`FbNB
          //  eXgʂACtsOnTime1050msOɍđMpPbgM邽߁A
          //    ]T݂1.2b(1200msjɂB
          // j
          // AñpPbgđMCTS=ONɂȂ邽߁AƂCTS ON Cxg邪A
          // ̎_ł͎Mobt@̂͂ł邩dMƂ͂Ȃ炢B
          EndTime := CtsOnTime + 1200;
          while (GetInQueSize < PHONE_NUMBER_PACKET_SIZE) and (GetTickCount < EndTime) do
            Sleep(10);
          QueSize := GetInQueSize;
          if QueSize = PHONE_NUMBER_PACKET_SIZE then begin
            TRACE('đMꂽMpPbgM܂B');

            // Mobt@ǂݏo
            Read(Packet, PHONE_NUMBER_PACKET_SIZE);

            // dbMnj
            Result := True;
          end


          else begin
            Msg := Format('đMꂽMpPbg̎M^CAEg܂͎Mf[^ُ픭iInQueSize=%dj', [QueSize]);
            TRACE(Msg);   // 2010/6/21ǉ

            // iȉA2010/7/8CȌj
            // ̒M̃G[̂ߑMobt@NAĂi2002/10/9j
            Sleep(100);
            TRACE_APICHK(
               PurgeComm(FHandle, PURGE_TXABORT or PURGE_TXCLEAR or PURGE_RXABORT or PURGE_RXCLEAR),
              'PurgeComm');
            RaiseAPC1Error(SAPC1ERR_ReadError,
                           CAPC1ERR_DETECT_ReadError);
          end;
        end;
      end


      //********************************************************************//
      // 肪MăAndbԍ󂯎Oɐ؂ꍇA           //
      // 邢̓Ań{^Ƃ͎MTCY 0 ɂȂB    //
      //********************************************************************//
      else begin
        Sleep(100);
        Msg := Format('ML[ɒMf[^Ă܂BiInQueSize=%dj', [GetInQueSize]);
        TRACE(Msg);   // 2010/6/21ǉ
      end;

    finally
      // rIʐMI
      EndHandshake;

      if Incoming then
        TRACE('***dbMI***');    // 2010/6/21ǉ
    end;
  end;
end;


// ȉA2010/6/21ȑÕR[h
//function TAlohaPC1Comm.DoCtsChanged_Thread(CtsOn: Boolean; var Packet: TPhoneNumberPacket): Boolean;
//const
//  WAIT_TIMEOUT = 1000; // M҂^CAEg
//var
//  EndTime: DWORD;
//  Ack: Char;
//  Incoming: Boolean;    // MtOi2010/6/21ǉj
//begin
//  Result := False;
//
//  if CtsOn then
//    TRACE('***bsrI***')
//  else
//    TRACE('***bsrIt***');
//
//
//  // ReadMemory܂WriteMemory\bhs̏ꍇ͉Ȃi2010/6/21ǉj
//  //  NeBJZNVŔr䂵Ă邪Ô߃tO`FbNǉB
//  if FReadWriteBusy then begin
//    TRACE('ǂݏoA܂̓os');
//    Exit;
//  end;
//
//
//  // bsrnm̂ƂɎMf[^ΒMf[^ubNǂݏo
//  if CtsOn then begin
//
//    // MtONA
//    Incoming := False;
//
//    // rIʐMJn
//    BeginHandshake;
//    try
//      if GetInQueSize > 0 then begin
//
//        // MtOZbg
//        Incoming := True;
//
//        TRACE('***dbMJn***');
//
//        // RPoCgM邩^CAEgɂȂ܂ő҂
//        EndTime := GetTickCount + WAIT_TIMEOUT;
//        while (GetInQueSize < PHONE_NUMBER_PACKET_SIZE) and (GetTickCount < EndTime) do
//          Sleep(10);
//
//        // Młꍇ
//        if GetInQueSize = PHONE_NUMBER_PACKET_SIZE then begin
//
//          TRACE('ML[ǂݏołԂɂȂ܂B');  // 2010/6/21ǉ
//
//          // Mobt@ǂݏo
//          Read(Packet, PHONE_NUMBER_PACKET_SIZE);
//
//          // qsrɗGbW
//          SetRts; Sleep(10); ClrRts;
//
//          // POOȏ҂
//          Sleep(100);
//
//
//
//          TRACE('ACK𑗐M܂'); // 2010/6/21ǉ
//
//          // ACK Ԃ
//          Ack := #6;
//          Write(Ack, 1);
//          Sleep(100); // M҂
//
//          // qsrnmɖ߂Ă
//          SetRts;
//
//          // dbMnj
//          Result := True;
//        end
//
//        // M^CAEg܂͎Mf[^ُ
//        else begin
//          // ̒M̃G[̂ߑMobt@NAĂi2002/10/9j
//          Sleep(100);
//          TRACE_APICHK(
//             PurgeComm(FHandle, PURGE_TXABORT or PURGE_TXCLEAR or PURGE_RXABORT or PURGE_RXCLEAR),
//            'PurgeComm');
//          RaiseAPC1Error(SAPC1ERR_ReadError,
//                         CAPC1ERR_DETECT_ReadError);
//        end;
//      end;
//    finally
//      // rIʐMI
//      EndHandshake;
//
//      if Incoming then
//        TRACE('***dbMI***');    // 2010/6/21ǉ
//    end;
//  end;
//end;


//**************************************************************************//
//  Name      | TAlohaPC1Comm.DoPhoneDetect                                 //
//  Comment   | db𒅐MƂ                                          //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Packet          | O | MdbԍpPbg                          //
//--------------------------------------------------------------------------//
//  Note      | ̃\bh̓Xbh񓯊IɌĂяoB          //
//**************************************************************************//
procedure TAlohaPC1Comm.DoPhoneDetect(const Packet: TPhoneNumberPacket);
var
  PPacket: PPhoneNumberPacket;
begin
  if Assigned(FOnPhoneDetect) then begin
    if FAsyncHandling then
      FOnPhoneDetect(Self, Packet)
    else begin
      PPacket := AllocMem(PHONE_NUMBER_PACKET_SIZE);
      Move(Packet, PPacket^, PHONE_NUMBER_PACKET_SIZE);
      PostMessage(FhSyncWnd, CM_ON_PHONE_DETECT, Integer(PPacket), 0);
    end;
  end;
end;

//**************************************************************************//
//  Name      | NewPChar                                                    //
//  Comment   | XgÕRs[ PChar f[^Ƃč쐬             //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  S               | I | Rs[̃XgO                              //
//--------------------------------------------------------------------------//
//  Result    | mۂ|C^                                      //
//**************************************************************************//
function NewPChar(const S: string): PChar;
begin
  Result := AllocMem(Length(S)+1);
  Move(PChar(S)^, Result^, Length(S));
  Result[Length(S)] := #0;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.DoError                                       //
//  Comment   | ĎXbhŗOƂ                          //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | ÕbZ[WXgO                //
//--------------------------------------------------------------------------//
//  Note      | ̃\bh̓Xbh񓯊IɌĂяoB          //
//**************************************************************************//
procedure TAlohaPC1Comm.DoError(const Msg: string);
begin
  // 񓯊Ăяop
  if Assigned(FOnAsyncError) then
    try FOnAsyncError(Self, Msg); except end;

  if Assigned(FOnError) then begin
    if FAsyncHandling then
      FOnError(Self, Msg)
    else
      PostMessage(FhSyncWnd, CM_ON_ERROR, Integer(NewPChar(Msg)), 0);
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.DoCommError                                   //
//  Comment   | ĎXbhŉG[                        //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  dwError         | I | G[eiClearCommErrorj                  //
//--------------------------------------------------------------------------//
//  Note      | ̃\bh̓Xbh񓯊IɌĂяoB          //
//**************************************************************************//
procedure TAlohaPC1Comm.DoCommError(dwError: DWORD);
begin
  // 񓯊Ăяop
  if Assigned(FOnAsyncCommError) then
    try FOnAsyncCommError(Self, dwError); except end;

  if Assigned(FOnCommError) then begin
    if FAsyncHandling then
      FOnCommError(Self, dwError)
    else
      PostMessage(FhSyncWnd, CM_ON_COMMERROR, dwError, 0);
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.DoTrace                                       //
//  Comment   | g[XbZ[W̏o                                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Msg             | I | bZ[W                                        //
//  Win32ErrCode    | I | WIN32API sG[eiGetLastErrorj           //
//--------------------------------------------------------------------------//
//  Result    | ĎXbhĂяo邱Ƃ_ɒӁB            //
//**************************************************************************//
procedure TAlohaPC1Comm.DoTrace(const Msg: string; Win32ErrCode: DWORD);
begin
  // 񓯊Ăяop
  if Assigned(FOnAsyncTrace) then
    try FOnAsyncTrace(Self, Msg, Win32ErrCode); except end;

  if Assigned(FOnTrace) then begin
    if FAsyncHandling then
      FOnTrace(Self, Msg, Win32ErrCode)
    else
      PostMessage(FhSyncWnd, CM_ON_TRACE, Integer(NewPChar(Msg)), Win32ErrCode);
  end;
end;

//**************************************************************************//
//  Name      | TAlohaPC1Comm.SyncWndProc                                   //
//  Comment   | ĎXbh̓pEBhEvVW                //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Message         |I/O| EBhEbZ[W                              //
//**************************************************************************//
procedure TAlohaPC1Comm.SyncWndProc(var Message: TMessage);
var
  PPacket: PPhoneNumberPacket;
  PMsg: PChar;
  Win32ErrCode: DWORD;
  dwError: DWORD;
begin
  // ftHg̃bZ[W
  with Message do
    Result := DefWindowProc(FhSyncWnd, Msg, WParam, LParam);

  case Message.Msg of

    // dbMCxg
    CM_ON_PHONE_DETECT:
      begin
        PPacket := PPhoneNumberPacket(Message.WParam);
        try
          FOnPhoneDetect(Self, PPacket^);
        finally
          FreeMem(PPacket);
        end;
      end;

    // G[
    CM_ON_COMMERROR:
      begin
        dwError := Message.WParam;
        FOnCommError(Self, dwError);
      end;

    // G[bZ[Wo
    CM_ON_ERROR:
      begin
        PMsg := PChar(Message.WParam);
        try
          FOnError(Self, string(PMsg));
        finally
          FreeMem(PMsg);
        end;
      end;

    // g[XbZ[Wo
    CM_ON_TRACE:
      begin
        PMsg := PChar(Message.WParam);
        Win32ErrCode := Message.LParam;
        try
          FOnTrace(Self, string(PMsg), Win32ErrCode);
        finally
          FreeMem(PMsg);
        end;
      end;
  end;
end;



end.
