//**************************************************************************//
//  Unit        | AnobPʐMR|[lgp݌vjbg            //
//  Version     | 1.00                                                      //
//--------------------------------------------------------------------------//
//  File Name   | DesignAlohaPC1Com.pas                                     //
//  Platform    | Windows2000                                               //
//  Compiler    | Delphi6                                                   //
//  Last Update | 2002/10/ 4                                                //
//--------------------------------------------------------------------------//
//  Copyright (c) 2002 Hitwareland Corporation.                             //
//  All rights reserved.                                                    //
//  programmed by Hitoshi Komatsu                                           //
//--------------------------------------------------------------------------//
//                      <<< Updated History >>>                             //
//--------------------------------------------------------------------------//
//  2002/10/ 4 | ΉJn                                                   //
//**************************************************************************//
unit DesignAlohaPC1Comm;

interface

procedure Register;

implementation

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   gpjbg錾                                                     //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
uses
  { Delphi }
  SysUtils, Classes, Consts,

  { Delphi Property Editor }
  // DsgnIntf, D4
{$IFDEF VER130} // D5
  DsgnIntf,
{$ELSE}
  DesignIntf, DesignEditors, TypInfo,
{$ENDIF}

  { AlohaPC1 Comm Component }
  AlohaPC1Comm;

//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
//                                                                          //
//   ʐM|[g͗pvpeBGfB^NX                           //
//                                                                          //
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX//
type
  TCommPortNameProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

//**************************************************************************//
//  Name      | TCommPortNameProperty.GetAttributes                         //
//  Comment   | ͑̎擾                                              //
//--------------------------------------------------------------------------//
//  Result    | T|[g͑                                        //
//**************************************************************************//
function TCommPortNameProperty.GetAttributes: TPropertyAttributes;
begin
  // IXg̑ÍAIXg̃\[g
  Result := [paValueList, paSortList, paRevertable];
end;

//**************************************************************************//
//  Name      | TCommPortNameProperty.GetValues                             //
//  Comment   | IXg̍ڌQ̗                                    //
//--------------------------------------------------------------------------//
//  Parameters      |I/O|                   Comment                         //
//------------------+---+---------------------------------------------------//
//  Proc            | I | 񋓐惋[`                                    //
//**************************************************************************//
procedure TCommPortNameProperty.GetValues(Proc: TGetStrProc);
var
  PortNames: TStringList;
  i: Integer;
begin
  // gpĂobŗpłVAʐM|[g񋓂
  PortNames := TStringList.Create;
  EnumSerialCommPortNames(PortNames);
  for i:=0 to (PortNames.Count-1) do
    Proc(PortNames.Strings[i]);
  PortNames.Free;
end;



//**************************************************************************//
//  Name      | Register                                                    //
//  Comment   | R|[lg̓o^                                        //
//**************************************************************************//
procedure Register;
begin
  // vpeBGfB^̓o^
  RegisterPropertyEditor(TypeInfo(string), TAlohaPC1Comm, 'PortName', TCommPortNameProperty);
end;



end.
